
[//]: # (the classpack LaTeX package)

# The classpack LaTeX2ε package

This is the README.md file for the classpack LaTeX package v1.28 (2024-02-21)
generated by ClassPack v.1.28 (2024-02-21) on 26 February 2024 at 13:47:16 

## Summary
%% 
LaTeX document classes and packages are conventionally created, maintained, and distributed in DocTeX (`.dtx`) format using the _ltxdoc_ class, which provides for interleaved code and documentation (“literate programming”). However, the accurate construction of these files is technically challenging, and editing them is tedious and error-prone.
%% 
_ClassPack_ allows a LaTeX developer to create a _DocBook5_ XML document for a class or package, containing the code interleaved with annotations, plus a section for the documentation. It provides an XSLT3 script to generate the `.dtx`, `.ins`, and other files, which can be suitably zipped up for submission to CTAN.
%% 
This is a development system for class and package authors. The `classpack.sty` file contains typographic adjustments and utilities only needed to typeset the documentation of _ClassPack_-produced classes or packages.
%% 
This software is a work-in-progress. It has been in development at Silmaril since 1998, and in production use since 2008. This release includes completion of the rewrite of the _AutoPackage_ algorithms, improved Makefile control, and a detailed update of the annotation of the XSLT code. A paper describing an earlier version was presented at a Balisage markup conference in Montréal (Flynn, 2013).

![](codepage-crop.pdf)


## Automated installation
%% 
If this package is distributed from [CTAN](https://ctan.org/pkg/classpack), it should be in a zip file which allows it to be installed automatically by the TeX Live Manager (_tlmgr_) and similar automated installers. If you are using automated LaTeX package installation, no further action is required.
%% 
If you are using the TeX Live Manager program manually, you can install this package with the command:

```bash
$ tlmgr install classpack
```


## TDS installation
%% 
This package is also available as a TeX Directory System (TDS) zip file (`.tds.zip`) from [the author’s package site](http://latex.silmaril.ie/packages/classpack). This is the standard directory layout for a modern TeX installation which enables the package to be unzipped directly into your Personal TeX Directory without the need to use _tlmgr_.
%% 
If you haven’t yet created a Personal TeX Directory, see [Formatting Information](http://latex.silmaril.ie/formattinginformation/) for details of what one is, and how to create it.

  *  You can install this package on any TDS-compliant personal system (laptop, desktop, workstation, table, smartphone, PDA, etc) by unzipping it straight into your Personal TeX Directory. This will put all the files into the right places, so you can start using them immediately.

  *  On a shared (multiuser) system like a server, the administrator can unzip it into the `$TEXMFLOCAL` directory instead (see below), and run your TeX directory-indexing program (eg _texhash_, _mktexlsr_, etc) so that everyone can use it.

  *  If you are using an old non-TDS-compliant system, or an online system with no TDS access, unzip the files _without their directory structure_ and put them all in your document directory.


## Usage
%% 
Include the line shown below in the Preamble of your LaTeX document; a `\documentclass` line should be at the top; a `\usepackage` command normally goes anywhere in your Preamble:

```LaTeX
\usepackage[options]{classpack}
```
%% 
(similarly for other classes or packages). Read the documentation for the options available, if any. The documentation is distributed as a PDF document in the zip file. You can also regenerate it by typesetting the `classpack.dtx` file with xelatex (and biber and _makeindex_) in the normal way.


## Bugs and TODO
%% 
No outstanding reported bugs at the time of this version.
%% 
For TODO items, see the PDF documentation.


## Copyright
%% 
The following statement is included in the source code:

     Transformed from classpack.xml by ClassPack db2dtx.xsl
     version 1.28 (2024-02-21) on Monday 26 February 2024 at 13:47:16
    
     classpack.sty is copyright © 2009-2024 by Peter Flynn <peter@silmaril.ie>
    
     This work may be distributed and/or modified under the
     conditions of the LaTeX Project Public License, either
     version 1.3 of this license or (at your option) any later
     version. The latest version of this license is in:
    
         http://www.latex-project.org/lppl.txt
    
     and version 1.3 or later is part of all distributions of
     LaTeX version 2005/12/01 or later.
    
     This work has the LPPL maintenance status ‘maintained’.
     
     The current maintainer of this work is Peter Flynn <peter@silmaril.ie>
    
     This work consists of the files classpack.dtx and classpack.ins,
     the derived files classpack.sty, doctexbook.dtd, db2dtx.xsl, db2bibtex.xsl, figtab2latex.xsl, db2md.xsl, classpack.make, decommentbbl.awk, chunk.sh, chunk.awk, 
     and any other ancillary files listed in the MANIFEST.
    

