<!-- The db2bibtex.xsl script (from the classpack package v.1.28, 2024-02-21) -->
<!-- Generated by ClassPack v.1.28 (2024-02-21) on 24-02-26T13:47:16 -->
<xsl:stylesheet
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  xmlns:db="http://docbook.org/ns/docbook"
  xmlns:xlink="http://www.w3.org/1999/xlink"
  xmlns:xs="http://www.w3.org/2001/XMLSchema"
  version="3.0">
  <xsl:variable name="apostrophe">'</xsl:variable>
  <xsl:template match="db:biblioref">
    <xsl:call-template name="compensate-space"/>
    <xsl:call-template name="makeref"/>
  </xsl:template>
  <xsl:template name="makeref">
    <xsl:choose>
      <xsl:when
        test="contains(normalize-space(@linkend),' ')">
        <xsl:text>\parencite{</xsl:text>
        <xsl:value-of
          select="translate(
                  normalize-space(@linkend),' ',',')"/>
        <xsl:text>}</xsl:text>
      </xsl:when>
      <xsl:when test="@xrefstyle='full'">
        <xsl:text>\fullcite{</xsl:text>
        <xsl:value-of select="@linkend"/>
        <xsl:text>}</xsl:text>
      </xsl:when>
      <xsl:otherwise>
        <xsl:variable name="target"
          select="//db:biblioentry
                  [@xml:id=current()/@linkend]"/>
        <xsl:choose>
          <xsl:when test="@xrefstyle='title'
                          or
                          @xrefstyle='titlecite'">
            <xsl:choose>
              <xsl:when
                test="$target/@xreflabel='article' or
                      $target/@xreflabel='inbook' or
                      $target/@xreflabel='incollection' or
                      $target/@xreflabel='inreference'">
                <xsl:text>`</xsl:text>
                <xsl:apply-templates
                  select="($target/descendant::db:title)
                          [1]/node()"/>
                <xsl:text>'</xsl:text>
              </xsl:when>
              <xsl:otherwise>
                <xsl:text>\emph{</xsl:text>
                <xsl:apply-templates
                  select="($target/descendant::db:title)
                          [1]/node()"/>
                <xsl:text>}</xsl:text>
              </xsl:otherwise>
            </xsl:choose>
            <xsl:if test="@xrefstyle='titlecite'">
              <xsl:text>~(\citeyear{</xsl:text>
              <xsl:value-of select="@linkend"/>
              <xsl:text>})</xsl:text>
            </xsl:if>
          </xsl:when>
          <xsl:when
            test="@xrefstyle='shorttitle'">
            <xsl:choose>
              <xsl:when
                test="$target/@xreflabel='article' or
                      $target/@xreflabel='inbook' or
                      $target/@xreflabel='incollection' or
                      $target/@xreflabel='inreference'">
                <xsl:text>`</xsl:text>
                <xsl:choose>
                  <xsl:when
                    test="$target
                          /descendant::db:titleabbrev">
                    <xsl:apply-templates
                      select="($target
                              /descendant::db:titleabbrev)
                              [1]/node()"/>
                  </xsl:when>
                  <xsl:otherwise>
                    <xsl:apply-templates
                      select="($target
                              /descendant::db:title)
                              [1]/node()"/>
                  </xsl:otherwise>
                </xsl:choose>
                <xsl:text>'</xsl:text>
              </xsl:when>
              <xsl:otherwise>
                <xsl:text>\emph{</xsl:text>
                <xsl:choose>
                  <xsl:when
                    test="$target
                          /descendant::db:titleabbrev">
                    <xsl:apply-templates
                      select="($target
                              /descendant::db:titleabbrev)
                              [1]/node()"/>
                  </xsl:when>
                  <xsl:otherwise>
                    <xsl:apply-templates
                      select="($target
                              /descendant::db:title)
                              [1]/node()"/>
                  </xsl:otherwise>
                </xsl:choose>
                <xsl:text>}</xsl:text>
              </xsl:otherwise>
            </xsl:choose>
            <xsl:if test="@xrefstyle='titlecite'">
              <xsl:text>~(\citeyear{</xsl:text>
              <xsl:value-of select="@linkend"/>
              <xsl:text>})</xsl:text>
            </xsl:if>
          </xsl:when>
          <xsl:when
            test="@xrefstyle='author' or
                  @xrefstyle='authors'">
            <xsl:for-each
              select="$target//db:author">
              <xsl:if
                test="preceding-sibling::db:author">
                <xsl:choose>
                  <xsl:when
                    test="following-sibling::db:author">
                    <xsl:if
                      test="count(../db:author)>2">
                      <xsl:text>, </xsl:text>
                    </xsl:if>
                  </xsl:when>
                  <xsl:otherwise>
                    <xsl:if test="count(../db:author)>2">
                      <xsl:text>,</xsl:text>
                    </xsl:if>
                    <xsl:text> and </xsl:text>
                  </xsl:otherwise>
                </xsl:choose>
              </xsl:if>
              <xsl:apply-templates
                select="db:personname
                        /db:firstname/node() |
                        db:orgname/node() |
                        db:personname
                        /db:othername/node()"/>
              <xsl:text> </xsl:text>
              <xsl:value-of
                select="db:personname
                        /db:surname/node() |
                        db:orgdiv/node()"/>
            </xsl:for-each>
          </xsl:when>
          <xsl:when
            test="@xrefstyle='shortauthor' or
                  @xrefstyle='shortauthors'">
            <xsl:for-each
              select="$target//db:author
                      /db:personname">
              <xsl:value-of
                select="db:surname"/>
            </xsl:for-each>
          </xsl:when>
          <xsl:otherwise>
            <xsl:if
              test="(//db:bibliography[@arch='biblatex']
                    or
                    //db:bibliolist[@arch='biblatex'])
                    and @xrefstyle='field'
                    and contains(@remap,'title')">
              <xsl:text>\emph{</xsl:text>
            </xsl:if>
            <xsl:text>\</xsl:text>
            <xsl:choose>
              <xsl:when
                test="(//db:bibliography[@arch='biblatex']
                       or
                       //db:bibliolist[@arch='biblatex'])
                      and
                      (@xrefstyle='text'
                       or
                       @xrefstyle='paren'
                       or
                       @xrefstyle='author(year)'
                       or
                       @xrefstyle='foot')">
                <xsl:value-of select="@xrefstyle"/>
              </xsl:when>
              <xsl:when
                test="(//db:bibliography[@arch='biblatex']
                       or
                       //db:bibliolist[@arch='biblatex'])
                      and not(@xrefstyle)">
                <xsl:text>paren</xsl:text>
              </xsl:when>
              <xsl:when
                test="ancestor::db:section and @xrefstyle">
                <xsl:value-of select="@xrefstyle"/>
              </xsl:when>
            </xsl:choose>
            <xsl:text>cite</xsl:text>
            <xsl:choose>
              <xsl:when
                test="(//db:bibliography[@arch='biblatex']
                      or
                      //db:bibliolist[@arch='biblatex'])
                      and @xrefstyle='field' and @remap">
                <xsl:text>field</xsl:text>
              </xsl:when>
              <xsl:when
                test="(//db:bibliography[@arch='biblatex']
                      or
                      //db:bibliolist[@arch='biblatex'])
                      and @xrefstyle='citetitle'">
                <xsl:text>title</xsl:text>
              </xsl:when>
              <xsl:when
                test="//db:bibliography
                      [@arch='bibtex' or not(@arch)]
                      and
                      @xrefstyle='text'">
                <xsl:text>A</xsl:text>
              </xsl:when>
            </xsl:choose>
            <xsl:if test="@role">
              <xsl:text>[</xsl:text>
              <xsl:choose>
                <xsl:when test="@role='firstname'">
                  <xsl:value-of
                    select="//db:bibliography
                            /db:biblioentry
                            [@xml:id=current()/@linkend]
                            //db:author[1]//db:firstname"/>
                </xsl:when>
                <xsl:otherwise>
                  <xsl:value-of select="@role"/>
                </xsl:otherwise>
              </xsl:choose>
              <xsl:text>]</xsl:text>
            </xsl:if>
            <xsl:if test="(@units and @begin)
                          or @annotations">
              <xsl:if test="not(@role)">
                <xsl:text>[]</xsl:text>
              </xsl:if>
              <xsl:text>[</xsl:text>
              <xsl:value-of select="@units"/>
              <xsl:if test="@units='p' and @end">
                <xsl:text>p.</xsl:text>
              </xsl:if>
              <xsl:text>\thinspace </xsl:text>
              <xsl:value-of select="@begin"/>
              <xsl:if test="@end">
                <xsl:text>--</xsl:text>
                <xsl:value-of select="@end"/>
              </xsl:if>
              <xsl:if test="@annotations">
                <xsl:if test="@units and @begin">
                  <xsl:text>, </xsl:text>
                </xsl:if>
                <xsl:value-of
                  select="normalize-space(
                          @annotations)"/>
              </xsl:if>
              <xsl:text>]</xsl:text>
            </xsl:if>
            <!-- floating URI afterwards -->
            <xsl:if test="@xlink:href">
              <xsl:text>[\protect\url{</xsl:text>
              <xsl:value-of
                select="replace(@xlink:href,'#','\\#')"/>
              <xsl:text>}]</xsl:text>
            </xsl:if>
            <xsl:text>{</xsl:text>
            <xsl:value-of
              select="translate(
                      normalize-space(@linkend),
                      ' ',',')"/>
            <xsl:text>}</xsl:text>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:otherwise>
    </xsl:choose>
    <xsl:if
      test="(//db:bibliography[@arch='biblatex']
            or
            //db:bibliolist[@arch='biblatex'])
            and @xrefstyle='field' and @remap">
      <xsl:text>{</xsl:text>
      <xsl:value-of select="@remap"/>
      <xsl:text>}</xsl:text>
      <xsl:if test="contains(@remap,'title')">
        <xsl:text>}</xsl:text>
      </xsl:if>
    </xsl:if>
  </xsl:template>
  <xsl:template match="db:bibliolist
                       [parent::db:section]"/>
  <xsl:template
    match="db:bibliography |
           db:bibliolist
           [not(ancestor::db:bibliography)
            and
            not(parent::db:section)]">
    <xsl:if test="db:title">
      <xsl:value-of select="$armour"/>
      <xsl:text>\renewcommand{\bibname}{</xsl:text>
      <xsl:value-of select="db:title"/>
      <xsl:text>}&#xa;</xsl:text>
    </xsl:if>
    <xsl:if
      test="(//db:exceptionname
             and not(//db:biblioref
                      [@linkend='rfc2119']))
            or
            (count(//db:biblioref) +
             count(//db:citetitle[@linkend]) +
             count(//db:blockquote[@linkend])=0)">
      <xsl:value-of select="$armour"/>
      <xsl:text>\nocite{*}&#xa;</xsl:text>
    </xsl:if>
    <xsl:if test="$armour!=''">
      <xsl:value-of select="$armour"/>
      <xsl:text>\clearpage&#xa;</xsl:text>
      <xsl:value-of select="$armour"/>
      <xsl:text>\raggedright&#xa;</xsl:text>
    </xsl:if>
    <xsl:variable name="file">
      <xsl:choose>
        <xsl:when test="@xlink:href">
          <xsl:value-of select="@xlink:href"/>
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="$name"/>
          <xsl:text>.bib</xsl:text>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <xsl:choose>
      <xsl:when test="local-name()='bibliography' and
                      (@arch='biblatex' or not(@arch))">
        <xsl:value-of select="$armour"/>
        <xsl:choose>
          <!-- @remap can specify an alternate style like shortbib -->
          <xsl:when test="@remap">
            <xsl:text>\RaggedRight</xsl:text>
            <xsl:text>\markboth{\refname}{\refname}</xsl:text>
          </xsl:when>
          <xsl:otherwise>
            <xsl:text>\raggedright</xsl:text>
          </xsl:otherwise>
        </xsl:choose>
        <xsl:text>\printbibliography</xsl:text>
        <xsl:if test="@remap">
          <xsl:text>[heading=</xsl:text>
          <xsl:value-of select="@remap"/>
          <xsl:text>]</xsl:text>
        </xsl:if>
        <xsl:text>\clearpage&#xa;</xsl:text>
      </xsl:when>
      <xsl:when
        test="local-name()='bibliography'
              and @arch='bibtex'">
        <xsl:value-of select="$armour"/>
        <xsl:text>\bibliography{</xsl:text>
        <xsl:value-of
          select="substring-before($file,'.bib')"/>
        <xsl:text>}&#xa;</xsl:text>
        <xsl:value-of select="$armour"/>
        <xsl:text>\bibliographystyle{</xsl:text>
        <xsl:choose>
          <xsl:when test="@label">
            <xsl:value-of select="@label"/>
          </xsl:when>
          <xsl:otherwise>
            <xsl:text>apacite</xsl:text>
          </xsl:otherwise>
        </xsl:choose>
        <xsl:text>}&#xa;</xsl:text>
      </xsl:when>
    </xsl:choose>
    <xsl:result-document format="textFormat"
      href="{$file}">
      <xsl:for-each-group group-by="@xreflabel"
        select="db:biblioentry">
        <xsl:sort select="current-grouping-key()"/>
        <xsl:text>&#xa;%% </xsl:text>
        <xsl:value-of
          select="upper-case(current-grouping-key())"/>
        <xsl:text>&#xa;</xsl:text>
        <xsl:apply-templates select="current-group()">
          <xsl:sort
            select="descendant::db:author[1]
                    /db:personname/db:surname
                    |
                    descendant::db:author[1]
                    /db:orgname"/>
          <xsl:sort select="db:date/@YYYY-MM-DD"/>
        </xsl:apply-templates>
      </xsl:for-each-group>
      <xsl:if test="//db:exceptionname
                    and not(db:biblioentry[@xml:id='rfc2119'])">
        <xsl:text>%% Added automatically</xsl:text>
        <xsl:apply-templates
          select="document('rfc2119.xml')
                  /db:section/db:bibliolist
                  /db:biblioentry"/>
      </xsl:if>
    </xsl:result-document>
  </xsl:template>

  <xsl:template match="db:bibliography/db:title"/>

  <xsl:template match="db:biblioentry">
    <xsl:text>&#xa;@</xsl:text>
    <xsl:choose>
      <xsl:when test="@xreflabel='standard' and @role">
        <xsl:text>techreport</xsl:text>
      </xsl:when>
      <xsl:when test="@xreflabel='patent'
                      or
                      @xreflabel='webpage'">
        <xsl:text>misc</xsl:text>
      </xsl:when>
      <xsl:otherwise>
        <xsl:value-of select="@xreflabel"/>
      </xsl:otherwise>
    </xsl:choose>
    <xsl:text>{</xsl:text>
    <xsl:value-of select="@xml:id"/>
    <xsl:apply-templates/>
    <xsl:if test="@xreflabel='standard' and @role">
      <xsl:text>,&#xa;  publisher &#x9; = {</xsl:text>
      <xsl:value-of select="@role"/>
      <xsl:text>}</xsl:text>
    </xsl:if>
    <xsl:if test="(@xreflabel='inproceedings'
                   or
                   @xreflabel='inreference')
                  and not(descendant::db:publisher)
                  and not(descendant::db:publishername)
                  and not(descendant::db:orgname)
                  and not(descendant::db:volumenum)
                  and not(descendant::db:issuenum)">
      <xsl:text>,&#xa;  publisher &#x9; = {Unpublished}</xsl:text>
    </xsl:if>
    <xsl:if test="not(descendant::db:date)
              and not(descendant::db:confnum[number(.)>999])
              and descendant::db:confdates">
      <xsl:for-each select="descendant::db:confdates[1]">
        <xsl:call-template name="dodate"/>
      </xsl:for-each>
    </xsl:if>
    <xsl:text>&#xa;}&#xa;</xsl:text>
  </xsl:template>
  <xsl:template match="db:bibliomisc">
    <xsl:text>,&#xa;  type &#x9; = {</xsl:text>
    <xsl:apply-templates/>
    <xsl:text>}</xsl:text>
  </xsl:template>
  <xsl:template match="db:biblioset | db:bibliomset">
    <xsl:choose>
      <xsl:when test="@relation='facsimile'">
        <xsl:text>,&#xa;  note &#x9; = {</xsl:text>
        <xsl:text>Facsimile edition </xsl:text>
        <xsl:if test="db:title[@role='translation']">
          <xsl:text>`</xsl:text>
          <xsl:value-of select="db:title"/>
          <xsl:text>'</xsl:text>
        </xsl:if>
        <xsl:if test="db:publisher">
          <xsl:text>, </xsl:text>
          <xsl:value-of
            select="db:publisher/db:publishername"/>
          <xsl:text>, </xsl:text>
          <xsl:value-of select="db:publisher/db:address"/>
        </xsl:if>
        <xsl:if test="db:date">
          <xsl:text>, </xsl:text>
          <xsl:value-of select="db:date"/>
        </xsl:if>
        <xsl:if test="db:address">
          <xsl:text>, in </xsl:text>
          <xsl:value-of select="db:address"/>
        </xsl:if>
        <xsl:text>.}</xsl:text>
      </xsl:when>
      <xsl:otherwise>
        <xsl:if test="@relation='inbook' and @remap">
          <xsl:text>,&#xa;  chapter &#x9; = {</xsl:text>
          <xsl:value-of select="@remap"/>
          <xsl:text>}</xsl:text>
        </xsl:if>
        <xsl:apply-templates/>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
  <xsl:template match="db:biblioentry//db:authorgroup">
    <xsl:apply-templates/>
    <xsl:if test="(db:author|db:editor)//db:affiliation">
      <xsl:text>,&#xa;  affiliation &#x9; = {</xsl:text>
      <xsl:for-each
        select="(db:author|db:editor)//db:affiliation">
        <xsl:variable name="bibentry"
          select="generate-id(ancestor::db:biblioentry)"/>
        <xsl:if
          test="count(preceding::db:affiliation
                [generate-id(ancestor::db:biblioentry)
                 =$bibentry]) > 0">
          <xsl:text> and </xsl:text>
        </xsl:if>
        <xsl:if test="db:orgdiv">
          <xsl:apply-templates select="db:orgdiv/node()"/>
          <xsl:text>, </xsl:text>
        </xsl:if>
        <xsl:apply-templates select="db:orgname/node()"/>
        <xsl:if test="db:address">
          <xsl:text>, </xsl:text>
          <xsl:apply-templates select="db:address/node()"/>
        </xsl:if>
      </xsl:for-each>
      <xsl:text>}</xsl:text>
    </xsl:if>
  </xsl:template>
  <xsl:template
    match="db:biblioentry//db:author |
           db:biblioentry//db:editor |
           db:biblioentry//db:authorgroup/db:author |
           db:biblioentry//db:authorgroup/db:editor">
    <!-- label if first -->
    <xsl:if
      test="count(preceding-sibling::*
            [name()=current()/name()])=0">
      <xsl:text>,&#xa;  </xsl:text>
      <xsl:value-of select="name()"/>
      <xsl:text> &#x9; = {</xsl:text>
    </xsl:if>
    <!-- separator otherwise -->
    <xsl:if
      test="preceding-sibling::*[name()=current()/name()]">
      <xsl:text> and </xsl:text>
    </xsl:if>
    <!-- each person, if there are any (maybe orgname) -->
    <xsl:for-each select="db:personname">
      <!-- normal first name -->
      <xsl:if test="db:firstname">
        <xsl:choose>
          <xsl:when test="db:firstname/@role='as-is'">
            <xsl:text>{</xsl:text>
            <xsl:value-of select="db:firstname"/>
            <xsl:text>}</xsl:text>
          </xsl:when>
          <xsl:otherwise>
            <xsl:value-of select="db:firstname"/>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:if>
      <!-- optional other name -->
      <xsl:if test="db:othername">
        <xsl:text> {</xsl:text>
        <xsl:value-of select="db:othername"/>
        <xsl:text>}</xsl:text>
      </xsl:if>
      <!-- special handling of spaces and punctuation in surnames -->
      <xsl:choose>
        <xsl:when
          test="contains(db:surname,' ')
                or
                contains(db:surname,' ')">
          <xsl:text> {</xsl:text>
          <xsl:value-of select="db:surname"/>
          <xsl:text>}</xsl:text>
        </xsl:when>
        <xsl:otherwise>
          <xsl:text> </xsl:text>
          <xsl:value-of select="db:surname"/>
        </xsl:otherwise>
      </xsl:choose>
      <xsl:if test="db:honorific">
        <xsl:text> </xsl:text>
        <xsl:value-of select="db:honorific"/>
      </xsl:if>
    </xsl:for-each>
    <xsl:choose>
      <!-- institutional organisation name -->
      <xsl:when test="db:orgname">
        <xsl:text>{</xsl:text>
        <xsl:choose>
          <!-- acronym -->
          <xsl:when test=".=upper-case(.)">
            <xsl:text>\acro{</xsl:text>
            <xsl:apply-templates/>
            <xsl:text>}</xsl:text>
          </xsl:when>
          <xsl:otherwise>
            <xsl:apply-templates/>
          </xsl:otherwise>
        </xsl:choose>
        <xsl:if test="db:orgdiv">
          <xsl:text> {</xsl:text>
          <xsl:apply-templates
            select="db:orgdiv/node()"/>
          <xsl:text>}</xsl:text>
        </xsl:if>
        <xsl:text>}</xsl:text>
      </xsl:when>
      <!-- just text? -->
      <xsl:otherwise>
        <xsl:text> </xsl:text>
      </xsl:otherwise>
    </xsl:choose>
    <xsl:if test="count(following-sibling::*
                  [name()=current()/name()])=0">
      <xsl:text>}</xsl:text>
    </xsl:if>
  </xsl:template>

  <xsl:template match="db:biblioentry//db:affiliation"/>
  <xsl:template match="db:biblioentry//db:corpauthor">
    <xsl:if
      test="count(preceding-sibling::db:author |
                  preceding-sibling::db:corpauthor)=0">
      <xsl:text>,&#xa;  author &#x9; = {{</xsl:text>
    </xsl:if>
    <xsl:if test="preceding-sibling::db:author |
                  preceding-sibling::db:corpauthor">
      <xsl:text> and </xsl:text>
    </xsl:if>
    <xsl:choose>
      <xsl:when test="@remap">
        <xsl:value-of select="@remap"/>
      </xsl:when>
      <xsl:when test="not(@remap)">
        <xsl:text>{</xsl:text>
        <xsl:apply-templates/>
        <xsl:text>}</xsl:text>
      </xsl:when>
      <xsl:otherwise>
        <xsl:apply-templates/>
      </xsl:otherwise>
    </xsl:choose>
    <xsl:if
      test="count(following-sibling::db:author |
                  following-sibling::db:corpauthor)=0">
      <xsl:text>}}</xsl:text>
      <xsl:if
        test="@remap and
              count(preceding-sibling::db:author |
                    preceding-sibling::db:corpauthor)=0">
        <xsl:text>,&#xa;  shortauthor &#x9; = {{</xsl:text>
        <xsl:value-of select="@remap"/>
        <xsl:text>}}</xsl:text>
      </xsl:if>
    </xsl:if>
  </xsl:template>
  <xsl:template match="db:org">
    <xsl:apply-templates/>
  </xsl:template>

  <xsl:template match="db:org/db:orgname">
    <xsl:text>,&#xa;  institution &#x9; = {{</xsl:text>
    <xsl:apply-templates/>
    <xsl:if test="following-sibling::db:orgdiv">
      <xsl:text>, </xsl:text>
      <xsl:apply-templates
        select="following-sibling::db:orgdiv/node()"/>
    </xsl:if>
    <xsl:text>}}</xsl:text>
  </xsl:template>

  <xsl:template match="db:org/db:orgdiv | db:author/db:orgdiv"/>
  <xsl:template match="db:biblioentry//db:title">
    <xsl:text>,&#xa;  </xsl:text>
    <xsl:choose>
      <xsl:when test="@role">
        <xsl:value-of select="@role"/>
      </xsl:when>
      <xsl:when
        test="parent::db:biblioset[@relation='article']">
        <xsl:text>title</xsl:text>
      </xsl:when>
      <xsl:when
        test="parent::db:biblioentry/@xreflabel='article'
              or
              parent::db:biblioset[@relation='journal']">
        <xsl:text>journaltitle</xsl:text>
      </xsl:when>
      <xsl:when
        test="(parent::db:biblioset/@relation='book' or
               parent::db:biblioset/@relation='reference')
              and (
                ancestor::db:biblioentry/
                          @xreflabel='incollection'
                or
                ancestor::db:biblioentry/
                          @xreflabel='inproceedings'
                or
                ancestor::db:biblioentry/
                          @xreflabel='inreference')">
        <xsl:text>booktitle</xsl:text>
      </xsl:when>
      <xsl:when
        test="parent::db:biblioentry and
              parent::db:biblioentry/db:biblioset
              [@relation='article']">
        <xsl:text>booktitle</xsl:text>
      </xsl:when>
      <xsl:otherwise>
        <xsl:text>title</xsl:text>
      </xsl:otherwise>
    </xsl:choose>
    <xsl:text> &#x9; = {{</xsl:text>
    <xsl:choose>
      <xsl:when test="count(*)=0">
        <xsl:value-of select="normalize-space(.)"/>
      </xsl:when>
      <xsl:otherwise>
        <xsl:apply-templates/>
      </xsl:otherwise>
    </xsl:choose>
    <xsl:if test="ancestor::db:bibliography
                  /@label='apacite'">
      <xsl:for-each
        select="following-sibling::db:subtitle
                [@role=current()/@role or
                (not(@role) and not(current()/@role))]">
        <xsl:choose>
          <xsl:when test="starts-with(.,'(')">
            <xsl:text> </xsl:text>
          </xsl:when>
          <xsl:when test="@remap">
            <xsl:text> \emph{</xsl:text>
            <xsl:value-of select="@remap"/>
            <xsl:text>} </xsl:text>
          </xsl:when>
          <xsl:otherwise>
            <xsl:text>: </xsl:text>
          </xsl:otherwise>
        </xsl:choose>
        <xsl:text>&#xa; &#x9; </xsl:text>
        <xsl:choose>
          <xsl:when test="count(*)=0">
            <xsl:value-of select="normalize-space(.)"/>
          </xsl:when>
          <xsl:otherwise>
            <xsl:apply-templates/>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:for-each>
    </xsl:if>
    <xsl:text>}}</xsl:text>
  </xsl:template>

  <xsl:template
    match="db:biblioentry//db:subtitle
           [ancestor::db:bibliography
            /@label='apacite']"/>

  <xsl:template
    match="db:biblioentry//db:subtitle
           [not(ancestor::db:bibliography
                /@label='apacite')]">
    <xsl:choose>
      <xsl:when
        test="parent::db:biblioset
              [@relation='book'
               or
               @relation='article']">
        <xsl:text>,&#xa;  subtitle &#x9; = {{</xsl:text>
      </xsl:when>
      <xsl:when
        test="parent::db:biblioset
              [@relation='journal']">
        <xsl:text>,&#xa;  journalsubtitle &#x9; = {{</xsl:text>
      </xsl:when>
      <xsl:when
        test="parent::db:biblioentry
              [@xreflabel='inbook'
               or
               @xreflabel='incollection'
               or
               @xreflabel='inreference']
              and
              parent::db:biblioentry/db:biblioset
              [@relation='article']">
        <xsl:text>,&#xa;  booksubtitle &#x9; = {{</xsl:text>
      </xsl:when>
      <xsl:otherwise>
        <xsl:text>,&#xa;  subtitle &#x9; = {{</xsl:text>
      </xsl:otherwise>
    </xsl:choose>
    <xsl:apply-templates/>
    <xsl:text>}}</xsl:text>
  </xsl:template>
  <xsl:template match="db:titleabbrev">
    <xsl:text>,&#xa;  shorttitle &#x9; = {{</xsl:text>
    <xsl:apply-templates/>
    <xsl:text>}}</xsl:text>
  </xsl:template>
  <xsl:template
    match="db:biblioid | db:isbn | db:issn">
    <xsl:text>,&#xa;  </xsl:text>
    <!-- fieldname -->
    <xsl:choose>
      <xsl:when test="@class='uri'">
        <xsl:text>url</xsl:text>
      </xsl:when>
      <xsl:when test="@class='doi'">
        <xsl:value-of select="@class"/>
      </xsl:when>
      <xsl:when test="@class='pubsnumber'">
        <xsl:text>titleaddon</xsl:text>
      </xsl:when>
      <xsl:when test="@class='other'">
        <xsl:text>titleaddon</xsl:text>
      </xsl:when>
      <xsl:when
        test="local-name()='isbn' or
              @class='isbn' or
              ancestor::db:biblioentry/@xreflabel='book'">
        <xsl:text>isbn</xsl:text>
      </xsl:when>
      <xsl:when
        test="local-name()='issn' or
              @class='issn' or
              ancestor::db:biblioentry/@xreflabel='article'">
        <xsl:text>issn</xsl:text>
      </xsl:when>
      <xsl:otherwise>
        <xsl:text>number</xsl:text>
      </xsl:otherwise>
    </xsl:choose>
    <xsl:text> &#x9; = {</xsl:text>
    <!-- shield -->
    <xsl:if test="@class='pubsnumber'">
      <xsl:text>{</xsl:text>
    </xsl:if>
    <!-- contents -->
    <xsl:choose>
      <xsl:when test="@class='other' and @otherclass">
        <xsl:value-of select="@otherclass"/>
        <xsl:text> </xsl:text>
      </xsl:when>
      <xsl:when test="@class='libraryofcongress'">
        <xsl:text>LoC</xsl:text>
        <xsl:text>: </xsl:text>
      </xsl:when>
    </xsl:choose>
    <!-- if content is a URI but it's not a URI field -->
    <xsl:if
      test="matches(.,'^http[s]?://')
            and
            not(@class='uri')">
      <xsl:text>\url{</xsl:text>
    </xsl:if>
    <!-- now the actual value -->
    <xsl:choose>
      <xsl:when test="@xlink:href">
        <xsl:value-of select="@xlink:href"/>
      </xsl:when>
      <xsl:otherwise>
        <xsl:value-of select="."/>
      </xsl:otherwise>
    </xsl:choose>
    <xsl:if
      test="matches(.,'^http[s]?://')
            and
            not(@class='uri')">
      <xsl:text>}</xsl:text>
    </xsl:if>
    <!-- shield -->
    <xsl:if test="@class='pubsnumber'">
      <xsl:text>}</xsl:text>
    </xsl:if>
    <xsl:text>}</xsl:text>
    <!-- generate additional fields: urldate -->
    <xsl:choose>
      <xsl:when
        test="@YYYY-MM-DD
              and
              (ancestor::db:bibliography/@label='apacite'
               or
               ancestor::db:bibliography/@label='apa')">
        <xsl:choose>
          <xsl:when
            test="ancestor::db:bibliography/@label='apacite'">
            <xsl:text>,&#xa;  lastchecked &#x9; = {</xsl:text>
            <xsl:value-of
              select="format-date(@YYYY-MM-DD,'[D] [MNn] [Y]')"/>
          </xsl:when>
          <xsl:otherwise>
            <xsl:text>,&#xa;  urldate &#x9; = {</xsl:text>
            <xsl:value-of select="@YYYY-MM-DD"/>
          </xsl:otherwise>
        </xsl:choose>
        <xsl:text>}</xsl:text>
      </xsl:when>
      <xsl:when
        test="@YYYY-MM-DD
              and
              not(ancestor::db:biblioentry//db:date)">
        <xsl:text>,&#xa;  year &#x9; = {</xsl:text>
        <xsl:value-of
          select="format-date(@YYYY-MM-DD,'[Y]')"/>
        <xsl:text>}</xsl:text>
        <xsl:if test="string-length(@YYYY-MM-DD)>5">
          <xsl:text>,&#xa;  month &#x9; = {</xsl:text>
          <!-- month with MNn is wrong for biber -->
          <xsl:value-of
            select="format-date(@YYYY-MM-DD,'[M]')"/>
          <xsl:text>}</xsl:text>
        </xsl:if>
      </xsl:when>
    </xsl:choose>
    <!-- note when it's a Usenet newsgroup -->
    <xsl:if test="matches(.,'^news:')">
      <xsl:text>,&#xa;  note &#x9; = {</xsl:text>
      <xsl:text>In Usenet newsgroup \texttt{</xsl:text>
      <xsl:value-of
        select="replace(substring-after(.,'news:')
                          ,'[^a-z\.].*$','')"/>
      <xsl:text>}, also available from Google Groups</xsl:text>
      <xsl:text>}</xsl:text>
    </xsl:if>
  </xsl:template>
  <xsl:template match="db:publisher">
    <xsl:choose>
      <xsl:when
        test="ancestor::db:biblioentry/@xreflabel='misc'">
        <xsl:text>,&#xa;  howpublished &#x9; = {</xsl:text>
        <xsl:apply-templates select="db:address/node()"/>
        <xsl:text>: </xsl:text>
        <xsl:apply-templates
          select="db:publishername/node()"/>
        <xsl:text>}</xsl:text>
      </xsl:when>
      <xsl:otherwise>
        <xsl:apply-templates/>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
  <xsl:template match="db:publishername">
    <xsl:text>,&#xa;  </xsl:text>
    <xsl:choose>
      <xsl:when
        test="ancestor::db:biblioentry/
              @xreflabel='techreport'
              or
              ancestor::db:biblioentry/
              @xreflabel='standard'
              or
              ancestor::db:biblioentry/
              @xreflabel='manual'">
        <xsl:text>organization</xsl:text>
      </xsl:when>
      <xsl:when
        test="ancestor::db:biblioentry/
              @xreflabel='phdthesis'
              or
              ancestor::db:biblioentry/
              @xreflabel='mastersthesis'">
        <xsl:text>institution</xsl:text>
      </xsl:when>
      <xsl:otherwise>
        <xsl:text>publisher</xsl:text>
      </xsl:otherwise>
    </xsl:choose>
    <xsl:text> &#x9; = {</xsl:text>
    <xsl:apply-templates/>
    <xsl:text>}</xsl:text>
  </xsl:template>
  <xsl:template match="db:publisher/db:address">
    <xsl:text>,&#xa;  </xsl:text>
    <xsl:choose>
      <xsl:when
        test="starts-with(normalize-space(.),'http://') or
              starts-with(normalize-space(.),'ftp://') or
              starts-with(normalize-space(.),'mailto:') or
              starts-with(normalize-space(.),'https://')">
        <xsl:text>url</xsl:text>
      </xsl:when>
      <xsl:otherwise>
        <xsl:text>address</xsl:text>
      </xsl:otherwise>
    </xsl:choose>
    <xsl:text> &#x9; = {</xsl:text>
    <xsl:apply-templates/>
    <xsl:text>}</xsl:text>
  </xsl:template>
  <xsl:template match="db:releaseinfo">
    <xsl:text>,&#xa;  version &#x9; = {</xsl:text>
    <xsl:value-of select="."/>
    <xsl:text>}</xsl:text>
  </xsl:template>
  <xsl:template match="db:confgroup">
    <xsl:apply-templates/>
  </xsl:template>

  <xsl:template match="db:confnum"/>
  <xsl:template match="db:conftitle">
    <xsl:text>,&#xa;  booktitle &#x9; = {{Proc. </xsl:text>
    <xsl:choose>
      <xsl:when test="../db:confnum">
        <xsl:choose>
          <xsl:when
            test="matches(.,'$apostrophe[0-9][0-9]$')">
            <xsl:value-of
              select="replace(.,
                      '$apostrophe[0-9][0-9]$','')"/>
          </xsl:when>
          <xsl:when
            test="matches(.,'’[0-9][0-9]$')">
            <xsl:value-of
              select="replace(.,'’[0-9][0-9]$','')"/>
          </xsl:when>
          <xsl:when
            test="matches(.,'[0-9][0-9]$')">
            <xsl:value-of
              select="replace(.,'[0-9][0-9]$','')"/>
          </xsl:when>
          <xsl:otherwise>
            <xsl:apply-templates/>
          </xsl:otherwise>
        </xsl:choose>
        <!-- now add the real year/number -->
        <xsl:choose>
          <xsl:when test="number(../db:confnum)>999">
            <xsl:text> </xsl:text>
            <xsl:value-of select="../db:confnum"/>
          </xsl:when>
          <xsl:otherwise>
            <xsl:apply-templates
              select="../db:confnum/node()"/>
            <xsl:text>: </xsl:text>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:when>
      <!-- otherwise it's just the name of the conf -->
      <xsl:otherwise>
        <xsl:apply-templates/>
      </xsl:otherwise>
    </xsl:choose>
    <!-- if there are dates, use biblatex -->
    <xsl:text>}}</xsl:text>
  </xsl:template>
  <xsl:template match="db:confsponsor">
    <xsl:text>,&#xa;  organization &#x9; = {</xsl:text>
    <xsl:apply-templates/>
    <xsl:text>}</xsl:text>
  </xsl:template>
  <xsl:template match="db:org/db:uri">
    <xsl:text>,&#xa;  uri &#x9; = {</xsl:text>
    <xsl:apply-templates/>
    <xsl:text>}</xsl:text>
  </xsl:template>
  <xsl:template match="db:confgroup/db:address">
    <xsl:text>,&#xa;  venue &#x9; = {</xsl:text>
    <xsl:apply-templates/>
    <xsl:text>}</xsl:text>
  </xsl:template>
  <xsl:template match="db:org/db:address">
    <xsl:text>,&#xa;  location &#x9; = {</xsl:text>
    <xsl:apply-templates/>
    <xsl:text>}</xsl:text>
  </xsl:template>
  <xsl:template match="db:confdates">
    <xsl:text>,&#xa;  eventdate &#x9; = {</xsl:text>
    <xsl:choose>
      <xsl:when test="@YYYY-MM-DD-from">
        <xsl:value-of select="@YYYY-MM-DD-from"/>
        <xsl:if test="@YYYY-MM-DD-to">
          <xsl:text>/</xsl:text>
          <xsl:value-of select="@YYYY-MM-DD-to"/>
        </xsl:if>
      </xsl:when>
      <xsl:otherwise>
        <xsl:value-of select="."/>
      </xsl:otherwise>
    </xsl:choose>
    <xsl:text>}</xsl:text>
  </xsl:template>
  <xsl:template match="db:date">
    <xsl:call-template name="dodate"/>
  </xsl:template>
  <xsl:template name="dodate">
    <xsl:text>,&#xa;  year &#x9; = {</xsl:text>
    <xsl:choose>
      <xsl:when test="@YYYY-MM-DD!=''">
        <xsl:value-of
          select="format-date(xs:date(
                  @YYYY-MM-DD),'[Y]')"/>
      </xsl:when>
      <xsl:when test="@YYYY-MM-DD-from!=''">
        <xsl:value-of
          select="format-date(xs:date(
                  @YYYY-MM-DD-from),'[Y]')"/>
      </xsl:when>
      <xsl:otherwise>
        <xsl:apply-templates/>
      </xsl:otherwise>
    </xsl:choose>
    <xsl:text>}</xsl:text>
    <xsl:choose>
      <xsl:when test="@YYYY-MM-DD!=''">
        <xsl:text>,&#xa;  month &#x9; = {</xsl:text>
        <xsl:value-of
          select="format-date(xs:date(
                  @YYYY-MM-DD),'[M]')"/>
        <xsl:text>}</xsl:text>
      </xsl:when>
      <xsl:when test="@YYYY-MM-DD-from!=''">
        <xsl:text>,&#xa;  month &#x9; = {</xsl:text>
        <xsl:value-of
          select="format-date(xs:date(
                  @YYYY-MM-DD-from),'[M]')"/>
        <xsl:text>}</xsl:text>
      </xsl:when>
    </xsl:choose>
    <xsl:if test="ancestor::db:biblioentry/@xreflabel='pc'">
      <xsl:text>,&#xa;  howpublished &#x9; = {</xsl:text>
      <xsl:text>Pers.\ Comm.}</xsl:text>
    </xsl:if>
  </xsl:template>
  <xsl:template match="db:pagenums | db:artpagenums">
    <xsl:choose>
      <xsl:when test="local-name()='pagenums'">
        <xsl:text>,&#xa;  pagetotal &#x9; = {</xsl:text>
      </xsl:when>
      <xsl:when test="local-name()='artpagenums'">
        <xsl:text>,&#xa;  pages &#x9; = {</xsl:text>
      </xsl:when>
    </xsl:choose>
    <xsl:choose>
      <!-- en-dash already present -->
      <xsl:when test="contains(.,'–')">
        <xsl:value-of select="substring-before(.,'–')"/>
        <xsl:text>--</xsl:text>
        <xsl:value-of select="substring-after(.,'–')"/>
      </xsl:when>
      <!-- double-hyphen -->
      <xsl:when test="contains(.,'--')">
        <xsl:value-of select="."/>
      </xsl:when>
      <!-- single hyphen -->
      <xsl:when test="contains(.,'-')">
        <xsl:value-of select="substring-before(.,'-')"/>
        <xsl:text>--</xsl:text>
        <xsl:value-of select="substring-after(.,'-')"/>
      </xsl:when>
      <xsl:otherwise>
        <xsl:value-of select="."/>
      </xsl:otherwise>
    </xsl:choose>
    <xsl:text>}</xsl:text>
  </xsl:template>
  <xsl:template match="db:volumenum">
    <xsl:choose>
      <xsl:when test="ancestor::db:biblioentry/@xreflabel='book'">
        <xsl:text>,&#xa;  volumes &#x9; = {</xsl:text>
      </xsl:when>
      <xsl:otherwise>
        <xsl:text>,&#xa;  volume &#x9; = {</xsl:text>
      </xsl:otherwise>
    </xsl:choose>
    <xsl:apply-templates/>
    <xsl:text>}</xsl:text>
  </xsl:template>
  <xsl:template match="db:issuenum | db:productnumber">
    <xsl:text>,&#xa;  number &#x9; = {</xsl:text>
    <xsl:apply-templates/>
    <xsl:text>}</xsl:text>
  </xsl:template>
  <xsl:template match="db:edition">
    <xsl:text>,&#xa;  edition &#x9; = {</xsl:text>
    <xsl:choose>
      <xsl:when test="not(number(.))">
        <xsl:apply-templates/>
      </xsl:when>
      <xsl:otherwise>
        <xsl:apply-templates/>
        <xsl:choose>
          <xsl:when
            test="substring(.,string-length(.))='1' and
                  substring(.,string-length(.)-1)!='11'">
            <xsl:text>st</xsl:text>
          </xsl:when>
          <xsl:when
            test="substring(.,string-length(.))='2' and
                  substring(.,string-length(.)-1)!='12'">
            <xsl:text>nd</xsl:text>
          </xsl:when>
          <xsl:when
            test="substring(.,string-length(.))='3' and
                  substring(.,string-length(.)-1)!='13'">
            <xsl:text>rd</xsl:text>
          </xsl:when>
          <xsl:otherwise>
            <xsl:text>th</xsl:text>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:otherwise>
    </xsl:choose>
    <xsl:text>}</xsl:text>
  </xsl:template>
  <xsl:template match="db:abstract">
    <xsl:text>,&#xa;  abstract &#x9; = {</xsl:text>
    <xsl:value-of select="normalize-space(.)"/>
    <xsl:text>}</xsl:text>
  </xsl:template>
  <xsl:template
    match="db:address[
           not(parent::db:publisher)
           and not(parent::db:confgroup)
           and not(parent::db:org)]">
    <xsl:text>,&#xa;  location &#x9; = {</xsl:text>
    <xsl:value-of select="normalize-space(.)"/>
    <xsl:text>}</xsl:text>
  </xsl:template>
  <xsl:template
    match="db:orgname[
           not(parent::db:author)
           and not(parent::db:org)]">
    <xsl:text>,&#xa;  institution &#x9; = {</xsl:text>
    <xsl:value-of select="normalize-space(.)"/>
    <xsl:text>}</xsl:text>
  </xsl:template>
  <xsl:template match="db:seriesvolnums |
                       db:biblioset[@relation='series']">
    <xsl:text>,&#xa;  series &#x9; = {</xsl:text>
    <xsl:value-of select="normalize-space(.)"/>
    <xsl:text>}</xsl:text>
  </xsl:template>
  <xsl:template match="db:bibliocoverage">
    <xsl:text>,&#xa;  chapter &#x9; = {</xsl:text>
    <xsl:value-of select="normalize-space(.)"/>
    <xsl:text>}</xsl:text>
  </xsl:template>
</xsl:stylesheet>

