<!-- The db2md.xsl script (from the classpack package v.1.28, 2024-02-21) -->
<!-- Generated by ClassPack v.1.28 (2024-02-21) on 24-02-26T13:47:16 -->
<xsl:stylesheet
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  xmlns:db="http://docbook.org/ns/docbook"
  xmlns:xlink="http://www.w3.org/1999/xlink"
  xmlns:sil="http://xml.silmaril.ie/identity/functions"
  xmlns:xs="http://www.w3.org/2001/XMLSchema"
  version="3.0">
  <xsl:variable name="maindoc" select="."/>

  <xsl:variable name="width">
    <xsl:text>72</xsl:text>
  </xsl:variable>
  <xsl:template mode="readme"
    match="db:title[not(parent::db:chapter) and
                    not(parent::db:sect1) and
                    not(parent::db:sect2) and
                    not(parent::db:sect3) and
                    not(parent::db:warning) and
                    not(parent::db:formalpara)]
                    |
           db:para[not(parent::db:listitem) and
                   not(parent::db:warning) and
                   not(parent::db:formalpara)]
                   |
           db:remark">
    <xsl:variable name="content">
      <xsl:apply-templates select="node()" mode="inline"/>
    </xsl:variable>
    <!-- blank line (previously elided in rendering MD???) -->
      <xsl:text>&#xa;</xsl:text>
    <!-- call the prefix-generator to handle the flag -->
    <xsl:call-template name="markup"/>
    <xsl:call-template name="normtext">
      <xsl:with-param name="content"
        select="normalize-space($content)"/>
      <xsl:with-param name="indent">
        <xsl:if
          test="ancestor::db:part[@xml:id='code']
                or
                ancestor::db:procedure
                [@xml:id='prepackage']">
          <xsl:value-of select="$sentinel"/>
        </xsl:if>
      </xsl:with-param>
    </xsl:call-template>
    <xsl:if test="ancestor::db:part[@xml:id!='code']">
      <xsl:text>&#xa;</xsl:text>
    </xsl:if>
  </xsl:template>
  <xsl:template match="db:chapter/db:title" mode="readme">
    <xsl:variable name="content">
      <xsl:apply-templates select="node()" mode="inline"/>
    </xsl:variable>
    <xsl:call-template name="markup">
      <xsl:with-param name="flag" select="'#'"/>
    </xsl:call-template>
    <xsl:call-template name="normtext">
      <xsl:with-param name="content"
        select="normalize-space($content)"/>
      <xsl:with-param name="indent">
        <xsl:if
          test="ancestor::db:part[@xml:id='code'] or
                ancestor::db:procedure[@xml:id='prepackage']">
          <xsl:value-of select="$sentinel"/>
        </xsl:if>
      </xsl:with-param>
    </xsl:call-template>
  </xsl:template>

  <xsl:template match="db:sect1/db:title" mode="readme">
    <xsl:variable name="content">
      <xsl:apply-templates select="node()" mode="inline"/>
    </xsl:variable>
    <xsl:call-template name="markup">
      <xsl:with-param name="flag" select="'##'"/>
    </xsl:call-template>
    <xsl:call-template name="normtext">
      <xsl:with-param name="content"
        select="normalize-space($content)"/>
      <xsl:with-param name="indent">
        <xsl:if
          test="ancestor::db:part[@xml:id='code'] or
                ancestor::db:procedure[@xml:id='prepackage']">
          <xsl:value-of select="$sentinel"/>
        </xsl:if>
      </xsl:with-param>
    </xsl:call-template>
  </xsl:template>

  <xsl:template match="db:sect2/db:title" mode="readme">
    <xsl:variable name="content">
      <xsl:apply-templates select="node()" mode="inline"/>
    </xsl:variable>
    <xsl:call-template name="markup">
      <xsl:with-param name="flag" select="'###'"/>
    </xsl:call-template>
    <xsl:call-template name="normtext">
      <xsl:with-param name="content"
        select="normalize-space($content)"/>
      <xsl:with-param name="indent">
        <xsl:if
          test="ancestor::db:part[@xml:id='code'] or
                ancestor::db:procedure[@xml:id='prepackage']">
          <xsl:value-of select="$sentinel"/>
        </xsl:if>
      </xsl:with-param>
    </xsl:call-template>
  </xsl:template>

  <xsl:template match="db:sect3/db:title" mode="readme">
    <xsl:variable name="content">
      <xsl:apply-templates select="node()" mode="inline"/>
    </xsl:variable>
    <xsl:call-template name="markup">
      <xsl:with-param name="flag" select="'####'"/>
    </xsl:call-template>
    <xsl:call-template name="normtext">
      <xsl:with-param name="content"
        select="normalize-space($content)"/>
      <xsl:with-param name="indent">
        <xsl:if
          test="ancestor::db:part[@xml:id='code'] or
                ancestor::db:procedure[@xml:id='prepackage']">
          <xsl:value-of select="$sentinel"/>
        </xsl:if>
      </xsl:with-param>
    </xsl:call-template>
  </xsl:template>

  <xsl:template match="db:bridgehead" mode="readme">
    <xsl:variable name="content">
      <xsl:apply-templates select="node()" mode="inline"/>
    </xsl:variable>
    <xsl:call-template name="markup">
      <xsl:with-param name="flag" select="'#####'"/>
    </xsl:call-template>
    <xsl:call-template name="normtext">
      <xsl:with-param name="content"
        select="normalize-space($content)"/>
      <xsl:with-param name="indent">
        <xsl:if
          test="ancestor::db:part[@xml:id='code'] or
                ancestor::db:procedure[@xml:id='prepackage']">
          <xsl:value-of select="$sentinel"/>
        </xsl:if>
      </xsl:with-param>
    </xsl:call-template>
  </xsl:template>
  <xsl:template match="db:warning" mode="readme">
    <xsl:if test="not(db:title)">
      <xsl:text>&#xa;> #### WARNING</xsl:text>
    </xsl:if>
    <xsl:apply-templates mode="readme"/>
    <xsl:text>&#xa;</xsl:text>
  </xsl:template>

  <xsl:template match="db:warning/db:title" mode="readme">
    <xsl:variable name="content">
      <xsl:apply-templates select="node()" mode="inline"/>
    </xsl:variable>
    <xsl:call-template name="markup">
      <xsl:with-param name="flag" select="'&#xa;> #### '"/>
    </xsl:call-template>
    <xsl:call-template name="normtext">
      <xsl:with-param name="content"
        select="normalize-space($content)"/>
      <xsl:with-param name="indent">
        <xsl:if
          test="ancestor::db:part[@xml:id='code'] or
                ancestor::db:procedure[@xml:id='prepackage']">
          <xsl:value-of select="$sentinel"/>
        </xsl:if>
      </xsl:with-param>
    </xsl:call-template>
  </xsl:template>
  <!-- This has to cope with being called from
       within db2dtx.xsl as well, to generate inline
       documentation that passes through to
       the .sty or .cls file -->
  <xsl:template
    match="db:para[parent::db:warning or
                   parent::db:formalpara]" mode="readme">
    <xsl:variable name="content">
      <xsl:apply-templates select="node()" mode="inline"/>
    </xsl:variable>
    <xsl:choose>
      <xsl:when test="ancestor::db:chapter[@xml:id='readme']">
        <xsl:text>> </xsl:text>
      </xsl:when>
      <xsl:otherwise>
        <xsl:text>&#xa;% </xsl:text>
      </xsl:otherwise>
    </xsl:choose>
    <xsl:value-of select="normalize-space($content)"/>
    <xsl:choose>
      <xsl:when test="ancestor::db:chapter[@xml:id='readme']">
        <xsl:text>&#xa;> </xsl:text>
      </xsl:when>
      <xsl:otherwise>
        <xsl:text>&#xa;% &#xa;</xsl:text>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
  <xsl:template match="db:formalpara/db:title" mode="readme">
    <xsl:variable name="content">
      <xsl:apply-templates select="node()" mode="inline"/>
    </xsl:variable>
    <xsl:call-template name="markup">
      <xsl:with-param name="flag" select="'> #### '"/>
    </xsl:call-template>
    <xsl:call-template name="normtext">
      <xsl:with-param name="content"
        select="normalize-space($content)"/>
      <xsl:with-param name="indent">
        <xsl:if
          test="ancestor::db:part[@xml:id='code'] or
                ancestor::db:procedure[@xml:id='prepackage']">
          <xsl:value-of select="$sentinel"/>
        </xsl:if>
      </xsl:with-param>
    </xsl:call-template>
    <xsl:call-template name="markup">
      <xsl:with-param name="flag"
        select="' ####&#xa;> &#xa;'"/>
    </xsl:call-template>
  </xsl:template>
  <xsl:template match="db:programlisting" mode="readme">
    <xsl:variable name="curdoctype">
      <xsl:value-of select="$maindoc/db:book/@arch"/>
    </xsl:variable>
    <xsl:if test="@condition=$curdoctype
                  or
                  not(@condition)">
      <xsl:variable name="content">
        <xsl:apply-templates select="node()"
          mode="inline"/>
      </xsl:variable>
      <xsl:call-template name="markup"/>
      <xsl:text>&#xa;</xsl:text>
      <!-- now github method -->
      <xsl:text>```</xsl:text>
      <xsl:if test="@language">
        <xsl:value-of select="@language"/>
      </xsl:if>
      <!-- was four leading spaces for MarkDown verbatim.
           do NOT expect to find escaped TeX in $content
      <xsl:for-each select="tokenize($content,'&#xa;')">
        <xsl:text>    </xsl:text>
        <xsl:value-of select="."/>
        <xsl:text>&#xa;</xsl:text>
      </xsl:for-each>
      -->
      <xsl:value-of select="replace($content,
                            '[ &#xa;&#x9;][ &#xa;&#x9;]*$',
                            '&#xa;')"/>
      <xsl:if
        test="not(matches(substring($content,
              string-length($content)),
              '[ \n\t]'))">
        <xsl:text>&#xa;</xsl:text>
      </xsl:if>
      <xsl:text>```&#xa;</xsl:text>
    </xsl:if>
  </xsl:template>
  <xsl:template match="db:exceptionname" mode="inline">
    <xsl:value-of select="upper-case(.)"/>
  </xsl:template>
  <xsl:template match="db:variablelist" mode="readme">
    <xsl:call-template name="markup">
      <xsl:with-param name="flag"
        select="'&#xa;&lt;dl>'"/>
    </xsl:call-template>
    <xsl:apply-templates mode="readme"/>
    <xsl:call-template name="markup">
      <xsl:with-param name="flag"
        select="'&#xa;&lt;/dl>&#xa;'"/>
    </xsl:call-template>
  </xsl:template>
  <xsl:template match="db:term" mode="readme">
    <xsl:variable name="content">
      <xsl:apply-templates select="node()" mode="inline"/>
    </xsl:variable>
    <xsl:call-template name="markup">
      <xsl:with-param name="flag"
        select="'&#xa;  &lt;dt>'"/>
    </xsl:call-template>
    <xsl:call-template name="normtext">
      <xsl:with-param name="content"
        select="normalize-space($content)"/>
      <xsl:with-param name="indent">
        <xsl:if
          test="ancestor::db:part[@xml:id='code'] or
                ancestor::db:procedure[@xml:id='prepackage']">
          <xsl:value-of select="$sentinel"/>
        </xsl:if>
      </xsl:with-param>
    </xsl:call-template>
    <xsl:choose>
      <!-- only add extra flag when outputting MD -->
      <xsl:when test="ancestor::db:book/@arch='script'">
        <xsl:text></xsl:text>
      </xsl:when>
      <xsl:otherwise>
        <xsl:call-template name="markup">
          <xsl:with-param name="flag" select="'&lt;/dt>'"/>
        </xsl:call-template>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
  <!-- inline list paragraph -->
  <xsl:template
    match="db:para
           [parent::db:listitem
             [parent::db:orderedlist
              or
              parent::db:itemizedlist]]"  mode="readme">
    <xsl:variable name="content">
      <xsl:apply-templates select="node()" mode="inline"/>
    </xsl:variable>
    <xsl:text>&#xa;</xsl:text>
    <xsl:call-template name="markup"/>
    <xsl:choose>
      <xsl:when test="ancestor::db:itemizedlist">
        <xsl:text>  *  </xsl:text>
      </xsl:when>
      <xsl:when test="ancestor::db:orderedlist">
        <xsl:text> </xsl:text>
        <xsl:if
          test="count(parent::db:listitem/
                      preceding-sibling::db:listitem)&lt;9">
          <xsl:text> </xsl:text>
        </xsl:if>
        <xsl:value-of
          select="count(parent::db:listitem/
                        preceding-sibling::db:listitem)+1"/>
        <xsl:text>. </xsl:text>
      </xsl:when>
    </xsl:choose>
    <xsl:call-template name="normtext">
      <xsl:with-param name="content"
        select="normalize-space($content)"/>
      <xsl:with-param name="indent">
        <xsl:if
          test="ancestor::db:part[@xml:id='code'] or
                ancestor::db:procedure[@xml:id='prepackage']">
          <xsl:value-of select="$sentinel"/>
        </xsl:if>
      </xsl:with-param>
    </xsl:call-template>
    <xsl:call-template name="markup"/>
  </xsl:template>
  <xsl:template match="db:para[ancestor::db:variablelist]
                       [not(parent::db:warning)]"
    mode="readme">
    <xsl:variable name="content">
      <xsl:apply-templates select="node()" mode="inline"/>
    </xsl:variable>
    <xsl:call-template name="markup">
      <xsl:with-param name="flag" select="'&#xa;  &lt;dd>'"/>
    </xsl:call-template>
    <xsl:call-template name="normtext">
      <xsl:with-param name="content"
        select="normalize-space($content)"/>
      <xsl:with-param name="indent">
        <xsl:if
          test="ancestor::db:part[@xml:id='code'] or
                ancestor::db:procedure[@xml:id='prepackage']">
          <xsl:value-of select="$sentinel"/>
        </xsl:if>
      </xsl:with-param>
    </xsl:call-template>
    <xsl:choose>
      <!-- only add extra flag when outputting MD -->
      <xsl:when test="ancestor::db:book/@arch='script'">
        <xsl:text></xsl:text>
      </xsl:when>
      <xsl:otherwise>
        <xsl:call-template name="markup">
          <xsl:with-param name="flag" select="'&lt;/dd>'"/>
        </xsl:call-template>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
  <xsl:template match="db:sect1" mode="readme">
    <xsl:choose>
      <xsl:when
        test="@xml:id='bugs' and
              $maindoc//db:revhistory/db:revision[1]/
              db:revdescription/db:orderedlist">
        <xsl:apply-templates mode="readme" select="db:title"/>
        <xsl:text>The following need attention:&#xa;&#xa;</xsl:text>
        <xsl:apply-templates  mode="readme"
          select="$maindoc//db:revhistory/db:revision[1]/
                  db:revdescription/db:orderedlist"/>
      </xsl:when>
      <xsl:otherwise>
        <xsl:apply-templates mode="readme"/>
      </xsl:otherwise>
    </xsl:choose>
    <xsl:text>&#xa;</xsl:text>
  </xsl:template>
  <xsl:template match="db:anchor" mode="readme">
    <xsl:variable name="loc" select="@targetptr"/>
    <xsl:variable name="pos" select="@type"/>
    <xsl:variable name="omit" select="@remap"/>
    <xsl:choose>
      <!-- special usage referencing a macro -->
      <xsl:when
        test="@targetptr='copyright' and @type='*'">
        <xsl:variable name="content">
          <xsl:for-each select="$maindoc">
            <xsl:call-template name="copyright-statement">
              <xsl:with-param name="ftype"
                select="/db:book/@userlevel"/>
            </xsl:call-template>
          </xsl:for-each>
        </xsl:variable>
        <xsl:text>&#xa;</xsl:text>
        <xsl:for-each select="tokenize($content,'&#xa;')">
          <xsl:text>    </xsl:text>
          <xsl:value-of select="replace(.,'^%','')"/>
          <xsl:text>&#xa;</xsl:text>
        </xsl:for-each>
      </xsl:when>
      <!-- normal operation, eg abstract -->
      <xsl:otherwise>
        <xsl:apply-templates mode="readme"
          select="$maindoc/
                  descendant::*[local-name()=$loc][1]
                  /*[local-name()!=$omit]"/>
        <!-- image -->
        <xsl:if
          test="$maindoc/
                descendant::*[local-name()=$loc][1]
                /@xlink:href">
          <xsl:for-each
            select="$maindoc/
                    descendant::*[local-name()=$loc][1]">
            <xsl:text>&#xa;![</xsl:text>
            <xsl:value-of select="normalize-space(@xlink:title)"/>
            <xsl:text>](</xsl:text>
            <xsl:if test="@vendor">
              <xsl:value-of select="@vendor"/>
            </xsl:if>
            <xsl:value-of select="@xlink:href"/>
            <xsl:text>)&#xa;</xsl:text>
          </xsl:for-each>
        </xsl:if>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
  <xsl:template match="db:olink" mode="inline">
    <xsl:call-template name="metadata"/>
  </xsl:template>
  <xsl:template match="db:literallayout" mode="inline">
    <xsl:choose>
      <xsl:when
        test="@language!='LaTeX' and @language!='TeX'">
        <!-- so this handles bash OK -->
        <xsl:variable name="content" select="."/>
        <xsl:call-template name="normtext">
          <xsl:with-param name="content"
            select="normalize-space($content)"/>
          <xsl:with-param name="indent">
            <xsl:if
              test="ancestor::db:part[@xml:id='code'] or
                    ancestor::db:procedure[@xml:id='prepackage']">
              <xsl:value-of select="$sentinel"/>
              <xsl:text>    </xsl:text>
            </xsl:if>
          </xsl:with-param>
        </xsl:call-template>
        <xsl:if test="ancestor::db:part[@xml:id!='code']">
          <xsl:text>&#xa;</xsl:text>
        </xsl:if>
      </xsl:when>
      <xsl:otherwise>
        <xsl:text>[Raw </xsl:text>
        <xsl:value-of select="@language"/>
        <xsl:text> code omitted here: see PDF doc]</xsl:text>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
  <xsl:template match="db:acronym" mode="inline">
    <xsl:call-template name="compensate-space"/>
    <xsl:choose>
      <xsl:when test="@xml:id">
        <xsl:apply-templates mode="inline"/>
        <xsl:text> (</xsl:text>
        <xsl:value-of select="@xml:id"/>
        <xsl:text>)</xsl:text>
      </xsl:when>
      <xsl:otherwise>
        <xsl:apply-templates mode="inline"/>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
  <xsl:template match="db:filename |
                       db:guilabel |
                       db:guibutton" mode="inline">
    <xsl:text>`</xsl:text>
    <xsl:apply-templates mode="inline"/>
    <xsl:text>`</xsl:text>
  </xsl:template>
  <xsl:template match="db:classname |
                       db:package" mode="inline">
    <xsl:text>_</xsl:text>
    <xsl:apply-templates mode="inline"/>
    <xsl:text>_</xsl:text>
  </xsl:template>
  <xsl:template match="db:uri" mode="inline">
    <xsl:apply-templates mode="inline"/>
  </xsl:template>
  <xsl:template match="db:phrase |
                       db:wordasword |
                       db:quote" mode="inline">
    <xsl:text>“</xsl:text>
    <xsl:apply-templates mode="inline"/>
    <xsl:text>”</xsl:text>
  </xsl:template>
  <xsl:template match="db:footnote" mode="inline">
    <xsl:text>&lt;sup></xsl:text>
    <xsl:number format="1" count="db:footnote" level="any"/>
    <xsl:text>&lt;/sup></xsl:text>
  </xsl:template>
  <xsl:template match="db:xref" mode="inline">
    <xsl:variable name="target"
      select="$maindoc//*[@xml:id=current()/@linkend]"/>
    <xsl:variable name="targetname"
      select="local-name($target)"/>
    <xsl:choose>
      <!-- handle informaltable, informalequation -->
      <xsl:when test="starts-with($targetname,'informal')">
        <xsl:text> the informal </xsl:text>
        <xsl:value-of
          select="substring-after($targetname,'informal')"/>
        <xsl:text> labelled ‘</xsl:text>
        <xsl:value-of select="@linkend"/>
        <xsl:text>’ in §</xsl:text>
        <xsl:variable name="ref">
          <xsl:for-each
            select="$target/ancestor::*
                    [not(name()='part' or name()='book')]">
            <ref n="{count(preceding-sibling::*
                     [name()=current()/name()]) + 1}">
              <xsl:value-of select="local-name()"/>
            </ref>
          </xsl:for-each>
        </xsl:variable>
        <xsl:for-each select="$ref/ref[@n>0]">
          <xsl:sort select="position()"
            order="descending"/>
          <xsl:value-of select="@n"/>
          <xsl:if test="position()!=last()">
            <xsl:text>.</xsl:text>
          </xsl:if>
        </xsl:for-each>
      </xsl:when>
      <xsl:otherwise>
        <xsl:text>the </xsl:text>
        <xsl:value-of select="$targetname"/>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
  <xsl:template match="db:link[@xlink:href]" mode="inline">
    <xsl:call-template name="compensate-space"/>
    <xsl:text>[</xsl:text>
    <xsl:choose>
      <xsl:when test="*">
        <xsl:apply-templates mode="inline"/>
      </xsl:when>
      <xsl:otherwise>
        <xsl:value-of select="."/>
      </xsl:otherwise>
    </xsl:choose>
    <xsl:text>](</xsl:text>
    <xsl:value-of select="replace(@xlink:href,'PACKAGE',$docname)"/>
    <xsl:text>)</xsl:text>
  </xsl:template>
  <xsl:template match="db:command" mode="inline">
    <xsl:text>`</xsl:text>
    <xsl:if test="@xml:lang='TeX' or
                  @xml:lang='LaTeX' or
                  not(@xml:lang)">
      <xsl:text>\</xsl:text>
    </xsl:if>
    <xsl:apply-templates mode="inline"/>
    <xsl:text>`</xsl:text>
  </xsl:template>
  <xsl:template match="db:tag" mode="inline">
    <xsl:text>`</xsl:text>
    <xsl:choose>
      <xsl:when test="@class='starttag'">
        <xsl:text>&lt;</xsl:text>
      </xsl:when>
      <xsl:when test="@class='attvalue'">
        <xsl:text>"</xsl:text>
      </xsl:when>
      <xsl:when test="@class='attribute' and
                      @conformance!='noat'">
        <xsl:text>@</xsl:text>
      </xsl:when>
      <xsl:when test="@class='genentity'">
        <xsl:text>&amp;</xsl:text>
      </xsl:when>
      <xsl:when test="@class='numcharref'">
        <xsl:text>&amp;\#x</xsl:text>
      </xsl:when>
    </xsl:choose>
    <!-- do NOT expect to find escaped TeX here -->
    <xsl:value-of select="."/>
    <xsl:choose>
      <xsl:when test="@class='starttag'">
        <xsl:text>&gt;</xsl:text>
      </xsl:when>
      <xsl:when test="@class='attvalue'">
        <xsl:text>"</xsl:text>
      </xsl:when>
      <xsl:when test="@class='genentity' or
                      @class='numcharref'">
        <xsl:text>;</xsl:text>
      </xsl:when>
    </xsl:choose>
    <xsl:text>`</xsl:text>
    <!-- separate plural "s" with space,
         otherwise rendering engines might hide it -->
    <xsl:if
      test="name(following-sibling::node()[1])='' and
                 starts-with(following-sibling::node()[1],'s')">
      <xsl:text> </xsl:text>
    </xsl:if>
  </xsl:template>
  <xsl:template match="text()" mode="inline">
    <xsl:choose>
      <xsl:when
        test="parent::db:emphasis[@role='strong']">
        <xsl:text>**</xsl:text>
        <!-- do NOT expect to find escaped TeX here -->
        <xsl:value-of select="."/>
        <xsl:text>**</xsl:text>
      </xsl:when>
      <xsl:when test="parent::db:firstterm">
        <xsl:text>**_</xsl:text>
        <!-- do NOT expect to find escaped TeX here -->
        <xsl:value-of select="."/>
        <xsl:text>_**</xsl:text>
      </xsl:when>
      <xsl:when test="parent::db:emphasis or
                      parent::db:productname or
                      parent::db:citetitle">
        <xsl:text>_</xsl:text>
        <xsl:call-template name="dologo"/>
        <xsl:text>_</xsl:text>
      </xsl:when>
      <xsl:when test="parent::db:option">
        <xsl:text>**`</xsl:text>
        <xsl:if
          test="parent::db:option/@language='bash'">
          <xsl:text>-</xsl:text>
        </xsl:if>
        <!-- do NOT expect to find escaped TeX here -->
        <xsl:value-of select="."/>
        <xsl:if
          test="parent::db:option/@language='bash'
                and
                not(parent::db:option/@conformance='nocolon')">
          <xsl:text>:</xsl:text>
        </xsl:if>
        <xsl:text>`**</xsl:text>
      </xsl:when>
      <xsl:when test="parent::db:varname">
        <xsl:text>`</xsl:text>
        <xsl:choose>
          <xsl:when
            test="parent::db:varname/@language='bash'">
            <xsl:text>$</xsl:text>
          </xsl:when>
          <xsl:when
            test="parent::db:varname/@language='LaTeX'">
            <xsl:text>\</xsl:text>
          </xsl:when>
        </xsl:choose>
        <!-- do NOT expect to find escaped TeX here -->
        <xsl:value-of select="."/>
        <xsl:text>`</xsl:text>
      </xsl:when>
      <xsl:otherwise>
        <xsl:call-template name="dologo"/>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
  <xsl:template match="db:biblioref" mode="inline">
    <xsl:text>(</xsl:text>
    <xsl:variable name="bibref" select="@linkend"/>
    <!-- change context to the entry -->
    <xsl:for-each
      select="$maindoc/descendant::db:biblioentry
              [@xml:id=$bibref]">
      <xsl:variable name="authors"
        select="count(descendant::db:author)"/>
      <!-- only name up to the first two -->
      <xsl:for-each
        select="descendant::db:author
                [count(preceding-sibling::db:author)&lt;2]">
        <xsl:if test="$authors>2
                      and
                      count(preceding-sibling::db:author)=1">
          <xsl:text>, </xsl:text>
        </xsl:if>
        <xsl:if
          test="count(preceding-sibling::db:author)=2">
          <xsl:text> &amp; </xsl:text>
        </xsl:if>
        <xsl:value-of select="db:personname/db:surname"/>
      </xsl:for-each>
      <xsl:if test="$authors>3">
        <xsl:text> et al</xsl:text>
      </xsl:if>
      <xsl:text>, </xsl:text>
      <xsl:choose>
        <xsl:when test="descendant::db:date">
          <xsl:value-of
            select="format-date
                    ((descendant::db:date)[1]/
                    @YYYY-MM-DD,'[Y]')"/>
        </xsl:when>
        <xsl:when test="descendant::db:confdates">
          <xsl:value-of
            select="format-date
                    ((descendant::db:confdates)[1]/
                    @YYYY-MM-DD-from,'[Y]')"/>
        </xsl:when>
        <xsl:otherwise>
          <xsl:text>n.d.</xsl:text>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:for-each>
    <xsl:text>)</xsl:text>
  </xsl:template>
  <xsl:template name="metadata">
    <xsl:variable name="loc" select="@targetptr"/>
    <xsl:variable name="ctl" select="@condition"/>
    <xsl:variable name="val" select="@arch"/>
    <xsl:variable name="pos" select="@type"/>
    <xsl:choose>
      <!-- test an attribute -->
      <xsl:when test="$ctl!=''">
        <xsl:choose>
          <!-- if a value is given -->
          <xsl:when test="$val!=''">
            <xsl:value-of select="$maindoc/
             descendant::*[local-name()=$loc]
             [@*[name()=$ctl]=$val][1]/@*[name()=$pos]"/>
          </xsl:when>
          <!-- if not, test for existence of $ctl attrib only -->
          <xsl:otherwise>
            <xsl:value-of select="$maindoc/
             descendant::*[local-name()=$loc]
             [@*[name()=$ctl]][1]/@*[name()=$pos]"/>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:when>
      <!-- no test, just get a value -->
      <xsl:otherwise>
        <xsl:value-of select="$maindoc/
         descendant::*[local-name()=$loc][1]/@*[name()=$pos]"/>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
  <xsl:template match="db:itemizedlist |
                       db:listitem |
                       db:sect2" mode="readme">
    <xsl:apply-templates mode="readme"/>
  </xsl:template>
  <xsl:template match="*" mode="readme">
    <xsl:message>
      <xsl:text>Unhandled readme '</xsl:text>
      <xsl:value-of select="name()"/>
      <xsl:text>'</xsl:text>
    </xsl:message>
    <xsl:apply-templates mode="readme"/>
  </xsl:template>
  <xsl:template name="markup">
    <xsl:param name="flag"/>
    <xsl:choose>
      <xsl:when
        test="ancestor::db:book/@arch='package' or
              ancestor::db:book/@arch='class'">
        <xsl:text></xsl:text>
      </xsl:when>
      <xsl:when test="$flag!=''">
        <xsl:text>&#xa;</xsl:text>
        <xsl:value-of select="$flag"/>
        <xsl:text> </xsl:text>
      </xsl:when>
      <xsl:when
        test="ancestor::db:book/@arch='script'">
        <!-- this gets done by the recursion anyway -->
        <xsl:text></xsl:text>
      </xsl:when>
      <xsl:otherwise>
        <xsl:text></xsl:text>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
  <xsl:template name="normtext">
    <xsl:param name="content"/>
    <xsl:param name="indent">
      <xsl:text></xsl:text>
    </xsl:param>
    <xsl:param name="prefix">
      <xsl:text></xsl:text>
    </xsl:param>
    <xsl:call-template name="set">
      <xsl:with-param name="text"
        select="replace(
                 replace(
                  replace(
                   replace(concat($prefix,$content),
                           '\\TeX\{\}','TeX'),
                          '\\LaTeX\{\}','LaTeX'),
                         '\\thinspace\{\}',' '),
                        '\\nicefrac(.)(.)','$1/$2')"/>
      <xsl:with-param name="indent" select="$indent"/>
    </xsl:call-template>
  </xsl:template>
  <xsl:template name="set">
    <xsl:param name="text"/>
    <xsl:param name="indent">
      <xsl:text></xsl:text>
    </xsl:param>
    <xsl:choose>
      <!-- if the string fits the width
           or if it's unbreakable, that's it -->
      <xsl:when test="string-length($text) &lt; $width
                      or
                      not(contains($text,' '))">
        <xsl:value-of select="$indent"/>
        <xsl:value-of select="$text"/>
        <xsl:text>&#xa;</xsl:text>
      </xsl:when>
      <xsl:otherwise>
        <xsl:variable name="line">
          <xsl:call-template name="token">
            <xsl:with-param name="text"
              select="$text"/>
            <xsl:with-param name="indent"
              select="$indent"/>
          </xsl:call-template>
        </xsl:variable>
        <xsl:value-of select="$line"/>
        <xsl:text>&#xa;</xsl:text>
        <xsl:call-template name="set">
          <xsl:with-param name="text"
            select="normalize-space(substring-after(
                    concat($indent,$text),$line))"/>
          <xsl:with-param name="indent"
            select="$indent"/>
        </xsl:call-template>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
  <xsl:template name="token">
    <xsl:param name="text"/>
    <xsl:param name="line">
      <xsl:text></xsl:text>
    </xsl:param>
    <xsl:param name="length">
      <xsl:text>0</xsl:text>
    </xsl:param>
    <xsl:param name="indent"/>
    <xsl:param name="cycle">
      <xsl:value-of select="number('0')"/>
    </xsl:param>
    <xsl:param name="context"/>
    <xsl:variable name="word">
      <xsl:choose>
        <xsl:when test="contains($text,' ')">
          <xsl:value-of
            select="substring-before($text,' ')"/>
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="$text"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <xsl:variable name="size"
      select="string-length($word)"/>
    <xsl:choose>
      <!-- too much for line -->
      <xsl:when test="$length + 1 + $size > $width">
        <xsl:value-of select="$line"/>
      </xsl:when>
      <!-- another word will fit -->
      <xsl:otherwise>
        <xsl:call-template name="token">
          <xsl:with-param name="line">
            <xsl:choose>
              <xsl:when test="$length=0">
                <!-- omit indent for lists on first cycle -->
                <xsl:choose>
                  <xsl:when
                    test="($context='itemizedlist' or
                          $context='orderedlist')
                          and $cycle = 0">
                    <xsl:text></xsl:text>
                  </xsl:when>
                  <xsl:otherwise>
                    <xsl:value-of select="$indent"/>
                  </xsl:otherwise>
                </xsl:choose>
                <xsl:value-of select="$word"/>
              </xsl:when>
              <xsl:otherwise>
                <xsl:value-of
                  select="concat($line,' ',$word)"/>
              </xsl:otherwise>
            </xsl:choose>
          </xsl:with-param>
          <xsl:with-param name="length">
            <xsl:choose>
              <xsl:when test="$length=0">
                <xsl:value-of
                  select="string-length($indent) + $size"/>
              </xsl:when>
              <xsl:otherwise>
                <xsl:value-of
                  select="string-length($line) + 1 + $size"/>
              </xsl:otherwise>
            </xsl:choose>
          </xsl:with-param>
          <xsl:with-param name="text"
            select="substring-after($text,' ')"/>
          <xsl:with-param name="cycle"
            select="$cycle + 1"/>
          <xsl:with-param name="context"
            select="$context"/>
        </xsl:call-template>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
  <xsl:template name="dologo">
    <xsl:choose>
      <xsl:when
        test="contains(.,'\BibTeX{}') or
              contains(.,'\Con\TeX t{}') or
              contains(.,'\LaTeX{}') or
              contains(.,'\LaTeXe{}') or
              contains(.,'\XeTeX{}') or
              contains(.,'\XeLaTeX{}') or
              contains(.,'\LyX{}') or
              contains(.,'\MF{}') or
              contains(.,'\MP{}') or
              contains(.,'\TeX{}')">
        <xsl:call-template name="detex">
          <xsl:with-param name="string" select="."/>
        </xsl:call-template>
      </xsl:when>
      <xsl:otherwise>
        <xsl:value-of select="."/>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
  <xsl:template name="detex">
    <xsl:param name="string"/>
    <xsl:choose>
      <xsl:when test="contains($string,'\BibTeX{}')">
        <xsl:call-template name="detex">
          <xsl:with-param name="string"
            select="replace($string,'\\BibTeX\{\}','BiBTeX')"/>
        </xsl:call-template>
      </xsl:when>
      <xsl:when test="contains($string,'\Con\TeX t{}')">
        <xsl:call-template name="detex">
          <xsl:with-param name="string"
            select="replace($string,'\\Con\\TeX t\{\}','ConTeXt')"/>
        </xsl:call-template>
      </xsl:when>
      <xsl:when test="contains($string,'\LaTeX{}')">
        <xsl:call-template name="detex">
          <xsl:with-param name="string"
            select="replace($string,'\\LaTeX\{\}','LaTeX')"/>
        </xsl:call-template>
      </xsl:when>
      <xsl:when test="contains($string,'\LaTeXe{}')">
        <xsl:call-template name="detex">
          <xsl:with-param name="string"
            select="replace($string,'\\LaTeXe\{\}','LaTeX2ε')"/>
        </xsl:call-template>
      </xsl:when>
      <xsl:when test="contains($string,'\XeTeX{}')">
        <xsl:call-template name="detex">
          <xsl:with-param name="string"
            select="replace($string,'\\XeTeX\{\}','XeTeX')"/>
        </xsl:call-template>
      </xsl:when>
      <xsl:when test="contains($string,'\XeLaTeX{}')">
        <xsl:call-template name="detex">
          <xsl:with-param name="string"
            select="replace($string,'\\XeLaTeX\{\}','XeLaTeX')"/>
        </xsl:call-template>
      </xsl:when>
      <xsl:when test="contains($string,'\LyX{}')">
        <xsl:call-template name="detex">
          <xsl:with-param name="string"
            select="replace($string,'\\LyX\{\}','LyX')"/>
        </xsl:call-template>
      </xsl:when>
      <xsl:when test="contains($string,'\MF{}')">
        <xsl:call-template name="detex">
          <xsl:with-param name="string"
            select="replace($string,'\\MF\{\}','METAFONT')"/>
        </xsl:call-template>
      </xsl:when>
      <xsl:when test="contains($string,'\MP{}')">
        <xsl:call-template name="detex">
          <xsl:with-param name="string"
            select="replace($string,'\\MP\{\}','METAPOST')"/>
        </xsl:call-template>
      </xsl:when>
      <xsl:when test="contains($string,'\TeX{}')">
        <xsl:call-template name="detex">
          <xsl:with-param name="string"
            select="replace($string,'\\TeX\{\}','TeX')"/>
        </xsl:call-template>
      </xsl:when>
      <xsl:otherwise>
        <xsl:value-of select="$string"/>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
</xsl:stylesheet>

