<!-- The figtab2latex.xsl script (from the classpack package v.1.28, 2024-02-21) -->
<!-- Generated by ClassPack v.1.28 (2024-02-21) on 24-02-26T13:47:16 -->
<xsl:stylesheet
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  xmlns:db="http://docbook.org/ns/docbook"
  xmlns:xlink="http://www.w3.org/1999/xlink"
  version="3.0">

  <xsl:output method="text"/>
  <xsl:template match="db:table">
    <!-- number of columns -->
    <xsl:variable name="ncols" select="db:tgroup/@cols"/>
    <!-- work out total table width -->
    <xsl:value-of select="$shield"/>
    <xsl:text> \setlength{\CPKtabwid}{</xsl:text>
    <xsl:call-template name="colwidths">
      <xsl:with-param name="loc" select="db:tgroup"/>
    </xsl:call-template>
    <xsl:text> + </xsl:text>
    <xsl:value-of select="$ncols - 1"/>
    <xsl:text>\tabcolsep}&#xa;</xsl:text>
    <!-- size and font control -->
    <xsl:if test="@wordsize">
    <xsl:value-of select="$shield"/>
      <xsl:text> \fontsize{</xsl:text>
      <xsl:value-of
        select="tokenize(@wordsize,'/')[1]"/>
      <xsl:text>}{</xsl:text>
      <xsl:value-of
        select="tokenize(@wordsize,'/')[2]"/>
      <xsl:text>}\selectfont</xsl:text>
    </xsl:if>
    <xsl:if test="@role">
      <xsl:if test="not(@wordsize)">
        <xsl:value-of select="$shield"/>
        <xsl:text> </xsl:text>
      </xsl:if>
      <xsl:value-of select="@role"/>
    </xsl:if>
    <xsl:if test="@wordsize or @role">
      <xsl:text>&#xa;</xsl:text>
    </xsl:if>
    <!-- start the table -->
    <xsl:value-of select="$shield"/>
    <xsl:text> \begin{</xsl:text>
    <xsl:value-of select="@condition"/><!-- eg 'long' -->
    <xsl:text>table}</xsl:text>
    <xsl:choose>
      <xsl:when test="@condition='long'">
        <xsl:text></xsl:text>
      </xsl:when>
      <xsl:when test="@floatstyle">
        <xsl:text>[</xsl:text>
        <xsl:value-of select="@floatstyle"/>
        <xsl:text>]</xsl:text>
      </xsl:when>
      <xsl:otherwise>
        <xsl:text>[ht]</xsl:text>
      </xsl:otherwise>
    </xsl:choose>
    <xsl:choose>
      <!-- longtable has to do column parse BEFORE caption etc -->
      <xsl:when test="@condition='long'">
        <xsl:for-each select="db:tgroup">
          <xsl:call-template name="colparse"/>
          <xsl:apply-templates select="../db:title|../db:subtitle"/>
          <xsl:apply-templates
            select="
                    db:thead|
                    db:tbody|
                    db:tfoot
                    "/>
        </xsl:for-each>
      </xsl:when>
      <!-- normal table -->
      <xsl:otherwise>
        <xsl:text>&#xa;</xsl:text>
        <xsl:apply-templates/>
      </xsl:otherwise>
    </xsl:choose>
    <!-- any prefaratory test gets output as the last row of tabular
         at the end of the tgroup template; longtables get it here -->
    <xsl:if test="db:textobject[@role='footer'] and @condition='long'">
      <xsl:value-of select="$shield"/>
      <xsl:text> \multicolumn{</xsl:text>
      <xsl:value-of select="$ncols"/>
      <xsl:text>}{>{\renewcommand{\baselinestretch}{0.8}</xsl:text>
      <xsl:text>\selectfont{}\centering{}\CPKprestrut}</xsl:text>
      <xsl:text>p{\CPKtabwid}}{\footnotesize&#xa;</xsl:text>
      <xsl:apply-templates
        select="db:textobject[@role='footer']/*"/>
      <xsl:value-of select="$shield"/>
      <xsl:text> }&#xa;</xsl:text>
      <xsl:value-of select="$shield"/>
      <xsl:text> \\&#xa;</xsl:text>
    </xsl:if>
    <xsl:value-of select="$shield"/>
    <xsl:text> \end{</xsl:text>
    <xsl:value-of select="@condition"/><!-- eg 'long' -->
    <xsl:text>table}&#xa;</xsl:text>
    <!-- size and font control -->
    <xsl:if test="@wordsize">
      <xsl:value-of select="$shield"/>
      <xsl:text> \normalsize</xsl:text>
    </xsl:if>
    <xsl:if test="@role">
      <xsl:if test="not(@wordsize)">
        <xsl:value-of select="$shield"/>
        <xsl:text> </xsl:text>
      </xsl:if>
      <xsl:text>\normalfont</xsl:text>
    </xsl:if>
    <xsl:if test="@wordsize or @role">
      <xsl:text>&#xa;</xsl:text>
    </xsl:if>
  </xsl:template>

  <xsl:template match="db:table/db:textobject
                       [@role='footer']"/>
  <xsl:template match="db:table/db:title[1]
                       |
                       db:figure/db:title[1]">
    <xsl:value-of select="$shield"/>
    <xsl:text> \caption</xsl:text>
      <!-- a second title is used for short caption -->
      <xsl:if test="following-sibling::db:title">
        <xsl:text>[</xsl:text>
        <xsl:apply-templates
          select="following-sibling::db:title/node()"/>
        <xsl:text>]</xsl:text>
      </xsl:if>
    <xsl:text>{</xsl:text>
    <xsl:apply-templates/>
    <xsl:text>}</xsl:text>
    <xsl:if test="../@xml:id
                  and
                  not(parent::db:table/@condition='long')">
      <xsl:text>\label{</xsl:text>
      <xsl:value-of select="../@xml:id"/>
      <xsl:text>}</xsl:text>
    </xsl:if>
    <xsl:choose>
      <xsl:when test="parent::db:table/@condition='long'">
        <xsl:text>\\&#xa;</xsl:text>
      </xsl:when>
      <xsl:otherwise>
        <xsl:text>\smallskip&#xa;</xsl:text>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>

  <xsl:template
    match="db:table/db:title[position()>1]
           |
           db:figure/db:title[position()>1]"/>
  <xsl:template match="db:informaltable">
    <xsl:value-of select="$shield"/>
    <xsl:text> \par\medskip{\sffamily</xsl:text>
    <xsl:choose>
      <xsl:when test="@role">
        <xsl:value-of select="@role"/>
      </xsl:when>
      <xsl:when test="@wordsize">
        <xsl:text>\fontsize{</xsl:text>
        <xsl:value-of
          select="tokenize(@wordsize,'/')[1]"/>
        <xsl:text>}{</xsl:text>
        <xsl:value-of
          select="tokenize(@wordsize,'/')[2]"/>
        <xsl:text>}\selectfont</xsl:text>
      </xsl:when>
      <xsl:otherwise>
        <xsl:text>\small</xsl:text>
      </xsl:otherwise>
    </xsl:choose>
    <xsl:if test="@xml:id">
      <xsl:text>\label{</xsl:text>
      <xsl:value-of select="@xml:id"/>
      <xsl:text>}</xsl:text>
    </xsl:if>
    <xsl:text>&#xa;</xsl:text>
    <xsl:apply-templates/>
    <xsl:value-of select="$shield"/>
    <xsl:text> }&#xa;</xsl:text>
  </xsl:template>
  <xsl:template
    match="db:informaltable/db:info">
    <xsl:text>\begin{center}</xsl:text>
    <xsl:apply-templates/>
    <xsl:text>\end{center}</xsl:text>
  </xsl:template>

  <xsl:template
    match="db:informaltable/db:info/db:title">
    <xsl:text>\textbf{</xsl:text>
    <xsl:apply-templates/>
    <xsl:text>}</xsl:text>
  </xsl:template>
  <xsl:template match="db:tgroup">
    <!-- formal and informal tables get their tabular-start here;
         longtable already did it -->
    <xsl:if test="not(ancestor::db:table/@condition='long')">
      <xsl:text>% \small\sffamily&#xa;</xsl:text>
      <xsl:call-template name="tabstart"/>
    </xsl:if>
    <!-- process the head lines if any -->
    <xsl:apply-templates select="db:thead"/>
    <!-- if there wasn't one, draw a rule -->
    <xsl:if test="not(db:thead)">
      <xsl:value-of select="$shield"/>
      <xsl:text> \hline&#xa;</xsl:text>
    </xsl:if>
    <!-- then do the body and the foot -->
    <xsl:apply-templates select="db:tbody"/>
    <xsl:apply-templates select="db:tfoot"/>
    <!-- formal and informal tables get their tabular-end here -->
    <xsl:if test="not(ancestor::db:table/@condition='long')">
      <!-- any prefaratory test gets output as the last row of longtable
           in the table template; normal tables get it here -->
      <xsl:if test="ancestor::db:table/db:textobject[@role='footer']
                    and not(ancestor::db:table/@condition='long')">
        <xsl:value-of select="$shield"/>
        <xsl:text> \multicolumn{</xsl:text>
        <xsl:value-of select="count(db:colspec)"/>
        <xsl:text>}{>{\renewcommand{\baselinestretch}{0.8}</xsl:text>
        <xsl:text>\selectfont{}\centering{}\CPKprestrut}</xsl:text>
        <xsl:text>p{\CPKtabwid}}{\footnotesize&#xa;</xsl:text>
        <xsl:apply-templates
          select="ancestor::db:table/db:textobject[@role='footer']/*"/>
        <xsl:value-of select="$shield"/>
        <xsl:text> }&#xa;</xsl:text>
        <xsl:value-of select="$shield"/>
        <xsl:text> \\&#xa;</xsl:text>
      </xsl:if>
      <xsl:value-of select="$shield"/>
      <xsl:text> \end{tabular}&#xa;</xsl:text>
    </xsl:if>
    <xsl:if
      test="starts-with(db:tbody/@xlink:href,'affil')
            and
            count(//db:part[@xml:id='data']
                  //db:constraintdef
                  [@xml:id=concat(substring-before(
                     current()/db:tbody/@xlink:href,'-'),
                           'options')]
                  /db:methodsynopsis[tokenize(@arch,' ')=
                     substring-after(
                     current()/db:tbody/@xlink:href,'-')]
                  [db:modifier])>0">
      <xsl:value-of select="$shield"/>
      <xsl:text> \scriptsize&#xa;</xsl:text>
      <xsl:value-of select="$shield"/>
      <xsl:text> \renewcommand{\labelenumi}{</xsl:text>
      <xsl:text>\itshape\alph{enumi}\upshape)}&#xa;</xsl:text>
      <xsl:text> \begin{enumerate}[noitemsep]&#xa;</xsl:text>
      <xsl:for-each
        select="//db:part[@xml:id='data']
                //db:constraintdef[@xml:id=
                concat(substring-before(
                   current()/db:tbody/@xlink:href,'-'),
                        'options')]
                /db:methodsynopsis[tokenize(@arch,' ')=
                   substring-after(
                   current()/db:tbody/@xlink:href,'-')]
                /db:modifier">
        <xsl:value-of select="$shield"/>
        <xsl:text>   \item The \texttt{</xsl:text>
        <xsl:value-of select="../@xml:id"/>
        <xsl:text>} option </xsl:text>
        <xsl:apply-templates/>
        <xsl:text>&#xa;</xsl:text>
      </xsl:for-each>
      <xsl:value-of select="$shield"/>
      <xsl:text> \end{enumerate}&#xa;</xsl:text>
      <xsl:value-of select="$shield"/>
      <xsl:text> \setcounter{fnote}{0}&#xa;</xsl:text>
    </xsl:if>
    <xsl:value-of select="$shield"/>
    <xsl:text> \par\endgroup&#xa;</xsl:text>
  </xsl:template>
  <xsl:template name="tabstart">
    <xsl:param name="loc">
      <xsl:text></xsl:text>
    </xsl:param>
    <!-- called in the context of db:tgroup -->
    <xsl:value-of select="$shield"/>
    <xsl:text> \begingroup</xsl:text>
    <xsl:value-of
      select="parent::db:table/@remap |
              parent::db:informaltable/@remap"/>
    <xsl:text>&#xa;</xsl:text>
    <xsl:value-of select="$shield"/>
    <xsl:text> \centering&#xa;</xsl:text>
    <xsl:value-of select="$shield"/>
    <xsl:text> \begin{tabular}</xsl:text>
    <xsl:call-template name="colparse"/>
  </xsl:template>

  <!-- colparse now separated out because of longtable support -->
  <xsl:template name="colparse">
    <xsl:param name="loc">
      <xsl:text></xsl:text>
    </xsl:param>
    <!-- WARNING: if you edit this, don't forget to mirror the edits
         in the colwidths template later on -->
    <xsl:text>{</xsl:text>
    <xsl:choose>
      <xsl:when test="@tgroupstyle='overhang' or @colsep='1'">
        <xsl:text>@{\quad}</xsl:text>
      </xsl:when>
      <xsl:otherwise>
        <xsl:text>@{}</xsl:text>
      </xsl:otherwise>
    </xsl:choose>
    <xsl:value-of select="$shield"/>
    <xsl:text>&#xa;</xsl:text>
    <xsl:value-of select="$shield"/>
    <!-- try to indent each column spec on its own line -->
    <xsl:text>   </xsl:text>
    <xsl:for-each select="db:colspec">
      <xsl:choose>
        <xsl:when test="@colsep='0'">
          <xsl:text>@{\enspace}</xsl:text>
        </xsl:when>
        <xsl:when test="@colsep='1'">
          <xsl:text>@{\qquad}</xsl:text>
        </xsl:when>
      </xsl:choose>
      <xsl:call-template name="colprefix">
        <xsl:with-param name="loc" select="$loc"/>
      </xsl:call-template>
      <xsl:call-template name="colsettings">
        <xsl:with-param name="loc" select="$loc"/>
      </xsl:call-template>
      <xsl:call-template name="colsuffix">
        <xsl:with-param name="loc" select="$loc"/>
      </xsl:call-template>
      <xsl:value-of select="$shield"/>
      <xsl:text>&#xa;</xsl:text>
      <xsl:value-of select="$shield"/>
      <xsl:text>   </xsl:text>
    </xsl:for-each>
    <xsl:choose>
      <xsl:when test="@tgroupstyle='overhang'">
        <xsl:text></xsl:text>
      </xsl:when>
      <xsl:otherwise>
        <xsl:text>@{}</xsl:text>
      </xsl:otherwise>
    </xsl:choose>
    <xsl:text>}&#xa;</xsl:text>
  </xsl:template>

  <!-- don't process the colspecs inline: they get managed as above -->
  <xsl:template match="db:colspec"/>
  <xsl:template name="colprefix">
    <xsl:param name="loc">
      <xsl:text></xsl:text>
    </xsl:param>
    <!-- @colwidth in <colspec>
         @condition for fonts, uses LaTeX code
         @wordsize in <entry>, here and below
         BUT header cells with no attributes
         masquerade as their colspec to get the
         settings, but set $loc to 'thead' -->
    <xsl:if test="@arch='leftrule'">
      <xsl:text>|</xsl:text>
    </xsl:if>
    <xsl:if test="@condition or @colwidth or @wordsize
                  or ancestor::db:thead or $loc='thead'">
      <xsl:text>>{</xsl:text>
      <xsl:variable name="nth">
        <xsl:choose>
          <xsl:when test="name()='colspec'">
            <xsl:value-of
              select="count(preceding-sibling::db:colspec)+1"/>
          </xsl:when>
          <xsl:otherwise>
            <xsl:value-of
              select="count(preceding-sibling::db:entry)+1"/>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:variable>
      <xsl:choose>
        <!-- go raggedright by default and
             narrow the linespacing for multiline columns -->
        <xsl:when
          test="(@align='left'
                 or
                 ancestor::db:tgroup/db:colspec
                   [position()=$nth]/@align='left')
                and
                (@colwidth
                 or
                 @wordsize
                 or
                 ancestor::db:thead or $loc='thead')">
          <xsl:text>\renewcommand{\baselinestretch}{0.8}</xsl:text>
          <xsl:text>\selectfont{}\raggedright{}</xsl:text>
        </xsl:when>
        <xsl:when
          test="(@align='right'
                 or
                 ancestor::db:tgroup/db:colspec
                   [position()=$nth]/@align='right')
                and
                (@colwidth
                 or
                 @wordsize
                 or
                 ancestor::db:thead or $loc='thead')">
          <xsl:text>\renewcommand{\baselinestretch}{0.8}</xsl:text>
          <xsl:text>\selectfont{}\raggedleft{}</xsl:text>
        </xsl:when>
        <xsl:when test="(@align='center'
                 or
                 ancestor::db:tgroup/db:colspec
                   [position()=$nth]/@align='center')
                and
                (@colwidth
                 or
                 @wordsize
                 or
                 ancestor::db:thead or $loc='thead')">
          <xsl:text>\renewcommand{\baselinestretch}{0.8}</xsl:text>
          <xsl:text>\selectfont{}\centering{}</xsl:text>
        </xsl:when>
        <!-- default is justified anyway,
             and char is inapplicable -->
        <xsl:when test="ancestor::db:thead">
          <xsl:text>\renewcommand{\baselinestretch}{0.8}</xsl:text>
          <xsl:text>\selectfont{}\raggedright{}</xsl:text>
        </xsl:when>
      </xsl:choose>
      <!-- condition is for typographic changes -->
      <xsl:if test="not($loc='thead')">
        <xsl:value-of select="@condition"/>
        <xsl:if test="@colwidth">
          <xsl:text>\renewcommand{\baselinestretch}{0.8}</xsl:text>
          <xsl:text>\selectfont{}</xsl:text>
        </xsl:if>
      </xsl:if>
      <xsl:text>\CPKprestrut</xsl:text>
      <xsl:if
        test="@wordsize and not($loc='thead')">
        <xsl:text>\fontsize{</xsl:text>
        <xsl:value-of
          select="tokenize(@wordsize,'/')[1]"/>
        <xsl:text>}{</xsl:text>
        <xsl:value-of
          select="tokenize(@wordsize,'/')[2]"/>
        <xsl:text>}\selectfont</xsl:text>
      </xsl:if>
      <xsl:if
        test="@align
              and
              (
                (name()='colspec'
                  and
                  count(following-sibling::db:colspec)=0)
                or
                 (name()='entry'
                  and
                  count(following-sibling::db:entry)=0)
              )
              and
              (@colwidth or @wordsize or @condition)">
        <xsl:text>\arraybackslash</xsl:text>
        <!--
        <xsl:text>align=</xsl:text>
        <xsl:value-of select="@align"/>
        <xsl:text>,name=</xsl:text>
        <xsl:value-of select="name()"/>
        <xsl:text>,cols=</xsl:text>
        <xsl:value-of select="count(following-sibling::db:colspec)"/>
        <xsl:text>,entries=</xsl:text>
        <xsl:value-of select="count(following-sibling::db:entry)"/>
        <xsl:text>,width=</xsl:text>
        <xsl:value-of select="@colwidth"/>
        <xsl:text>,size=</xsl:text>
        <xsl:value-of select="@wordsize"/>
        <xsl:text>,cond=</xsl:text>
        <xsl:value-of select="@condition"/>
        -->
      </xsl:if>
      <xsl:text>}</xsl:text>
    </xsl:if>
  </xsl:template>
  <xsl:template name="colsettings">
    <xsl:param name="loc">
      <xsl:text></xsl:text>
    </xsl:param>
    <!-- this is the type of column (p|m|b) and width -->
    <xsl:choose>
      <xsl:when test="@colwidth">
        <xsl:choose>
          <!-- for db:thead it's always 'b' -->
          <xsl:when test="$loc='thead'">
            <xsl:text>b</xsl:text>
          </xsl:when>
          <xsl:when test="@char='m' or @char='b'">
            <xsl:value-of select="@char"/>
          </xsl:when>
          <xsl:otherwise>
            <xsl:text>p</xsl:text>
          </xsl:otherwise>
        </xsl:choose>
        <xsl:text>{</xsl:text>
        <xsl:choose>
          <xsl:when test="@colwidth='widest'">
            <xsl:text>\widthof{</xsl:text>
            <xsl:call-template name="getlongest"/>
            <xsl:text>}</xsl:text>
          </xsl:when>
          <xsl:when test="contains(@colwidth,'%')">
            <xsl:value-of
              select="number(substring-before(
                      @colwidth,'%'))
                      div 100"/>
            <xsl:text>\columnwidth</xsl:text>
          </xsl:when>
          <xsl:otherwise>
            <xsl:value-of select="@colwidth"/>
          </xsl:otherwise>
        </xsl:choose>
        <xsl:text>}</xsl:text>
      </xsl:when>
      <!-- otherwise width not specified -->
      <xsl:otherwise>
        <xsl:choose>
          <!-- for db:thead it's always 'b' -->
          <xsl:when test="$loc='thead'">
            <xsl:text>b{\widthof{</xsl:text>
            <xsl:call-template name="getlongest"/>
            <!-- make this the longest tbody entry, not thead -->

            <!-- this doesn't work:
            <xsl:value-of
              select="following-sibling::db:tbody
                      /db:row/db:entry[position()=$nth]
                       [not(../db:row/db:entry[position()=$nth]
                        /string-length()
                        > current()/string-length())]"/>
            -->
            <!-- and Saxon PE needed for this one:
              select="sort(following-sibling::db:tbody
                           /db:row/db:entry[position()=$nth],
                           function($c)
                           {string-length($c)})[last()]"/>
            -->

            <!-- append 's' to account for
                 extra width of bold type 2020-04-24 -->
            <xsl:text>s}}</xsl:text>
          </xsl:when>
          <xsl:when test="@align='left' or
                          @align='right' or
                          @align='center'">
            <xsl:value-of
              select="substring(@align,1,1)"/>
          </xsl:when>
          <xsl:when test="@align='char'">
            <xsl:text>d</xsl:text>
          </xsl:when>
          <!-- justified is implied by
               @colwidth above -->
        </xsl:choose>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
  <xsl:template name="colsuffix">
    <xsl:param name="loc">
      <xsl:text></xsl:text>
    </xsl:param>
    <xsl:if test="@conformance
                  or
                  (@align!='left'
                   and
                   @align!='right'
                   and
                   @align!='center')
                  or
                  count(following-sibling::db:colspec)=0">
      <xsl:text>&lt;{</xsl:text>
      <xsl:value-of
        select="normalize-space(@conformance)"/>
      <xsl:if test="@align!='left' and
                    @align!='right' and
                    @align!='center'">
        <xsl:text>\CPKpoststrut</xsl:text>
      </xsl:if>
      <!-- why was this needed in colsuffixes?
      <xsl:if test="count(following-sibling::db:colspec)=0">
        <xsl:text>\arraybackslash</xsl:text>
      </xsl:if>
      -->
      <xsl:text>}</xsl:text>
    </xsl:if>
  </xsl:template>
  <xsl:template match="db:thead">
    <xsl:apply-templates/>
    <xsl:text>[2pt]\hline</xsl:text>
    <xsl:if test="ancestor::db:table/@condition='long'">
      <xsl:text>\endhead</xsl:text>
    </xsl:if>
    <xsl:text>&#xa;</xsl:text>
  </xsl:template>
  <xsl:template match="db:tbody">
    <xsl:value-of select="$shield"/>
    <xsl:text> </xsl:text>
    <xsl:if test="not(db:row[1]/db:entry[1]/@spanname)">
      <xsl:text>\CPKvstrut </xsl:text>
    </xsl:if>
    <xsl:if test="ancestor::db:table/@condition='long'
                  and
                  ancestor::db:table/@xml:id">
      <xsl:text>\label{</xsl:text>
      <xsl:value-of select="ancestor::db:table/@xml:id"/>
      <xsl:text>}%</xsl:text>
    </xsl:if>
    <xsl:text>&#xa;</xsl:text>
    <!-- obsolete, was used in ucc thesis
         eg, xlink:href='deg-acsss'
         to use the external tables
    <xsl:choose>
      <xsl:when
        test="@xlink:href and @xlink:show='embed'">
        <xsl:apply-templates mode="row"
          select="//db:part[@xml:id='data']
                  //db:constraintdef[@xml:id=
                  concat(substring-before(
                     current()/@xlink:href,'-'),
                         'options')]
                  /db:methodsynopsis
                  [tokenize(@arch,' ')=
                   substring-after(
                      current()/@xlink:href,'-')]">
          <xsl:sort select="@xml:id"/>
        </xsl:apply-templates>
      </xsl:when>
      <xsl:otherwise>
        <xsl:apply-templates/>
      </xsl:otherwise>
    </xsl:choose>
    -->
    <xsl:apply-templates/>
  </xsl:template>
  <xsl:template match="db:methodsynopsis" mode="row">
    <!-- each of these produces one row of the table -->
    <xsl:value-of select="$shield"/>
    <xsl:text> </xsl:text>
    <!-- signal a footnote if needed -->
    <xsl:if test="db:modifier">
      <xsl:text>\fnote{}</xsl:text>
    </xsl:if>
    <!-- col 1: token for option -->
    <xsl:value-of select="@xml:id"/>
    <xsl:text>&amp;%&#xa;</xsl:text>
    <!-- col 2: division[s],
         may be multiple methodparam elements -->
    <xsl:for-each select="db:methodparam/db:parameter">
      <xsl:value-of select="$shield"/>
      <xsl:text>&#x9;</xsl:text>
      <!-- @remap is a prefix
           except for institutes and centres -->
      <xsl:if test="not(@remap='') and
                    @role!='institute' and
                    @role!='centre'">
        <xsl:value-of
          select="normalize-space(@remap)"/>
        <xsl:text> </xsl:text>
      </xsl:if>
      <!-- the name -->
      <xsl:apply-templates/>
      <!-- @remap is a suffix for
           institutes and centres -->
      <xsl:if test="not(@remap='') and
                       (@role='institute' or
                        @role='centre')">
        <xsl:text> </xsl:text>
        <xsl:value-of
          select="normalize-space(@remap)"/>
      </xsl:if>
      <!-- any following divisions involved
           (only for affiliations) -->
      <xsl:choose>
        <xsl:when test="position()!=last()">
          <xsl:text>; </xsl:text>
        </xsl:when>
        <!-- dummy to terminate
             degree options cleanly -->
        <xsl:when test="@role='degree'">
          <xsl:text></xsl:text>
        </xsl:when>
        <xsl:otherwise>
          <xsl:text>&amp;%&#xa;</xsl:text>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:for-each>
    <!-- citation format -->
    <xsl:if
      test="not(db:methodparam/db:parameter
                /@role='degree')">
      <xsl:value-of select="$shield"/>
      <xsl:text>&#x9;</xsl:text>
      <xsl:value-of select="db:methodname"/>
    </xsl:if>
    <xsl:text>\\\hline[.1pt]%&#xa;</xsl:text>
  </xsl:template>
  <!-- omit rows with @condition and some weird zero value -->
  <xsl:template
    match="db:row[@condition
           and
           count($thisdoc//*
                 [name()=name(current()/db:entry[1]/*[1])])
                 = 0]"/>
  <!-- normal rows -->
  <xsl:template
    match="db:row[not(@condition)
           or
           count($thisdoc//*
                 [name()=name(current()/db:entry[1]/*[1])])
                 > 0]">
    <xsl:value-of select="$shield"/>
    <xsl:text> </xsl:text>
    <xsl:if test="@role='header'">
      <!-- extra space except on first row -->
      <xsl:if test="count(preceding-sibling::db:row) > 1">
        <xsl:text>[2pt]\hline&#xa;</xsl:text>
        <xsl:value-of select="$shield"/>
        <xsl:text> </xsl:text>
      </xsl:if>
    </xsl:if>
    <xsl:if test="@role='groupstart'">
      <xsl:if test="count(preceding-sibling::db:row) > 1">
        <xsl:text>[2pt]\hline\hline&#xa;</xsl:text>
        <xsl:value-of select="$shield"/>
        <xsl:text> </xsl:text>
      </xsl:if>
    </xsl:if>
    <xsl:apply-templates/>
    <xsl:text>\\</xsl:text>
    <xsl:choose>
      <xsl:when test="starts-with(@role,'sep')">
        <xsl:text>[</xsl:text>
        <xsl:value-of select="substring-after(@role,'sep')"/>
        <xsl:text>]</xsl:text>
      </xsl:when>
      <xsl:when test="@role='header'">
        <xsl:text>[2pt]\hline\CPKvstrut</xsl:text>
      </xsl:when>
      <xsl:when
        test="(ancestor::db:tbody or ancestor::db:tfoot)
              and position()=last()">
        <xsl:text>[2pt]\hline</xsl:text>
      </xsl:when>
      <xsl:when
        test="parent::*[1]/db:row[1][@rowsep='1']">
        <xsl:text>[1ex]</xsl:text>
      </xsl:when>
      <xsl:when
        test="ancestor::db:tbody/@style='ruled'">
        <xsl:text>\hline</xsl:text>
      </xsl:when>
    </xsl:choose>
    <xsl:if test="not(ancestor::db:thead)">
      <xsl:text>&#xa;</xsl:text>
    </xsl:if>
    <xsl:if test="@remap='newpage'">
      <xsl:value-of select="$shield"/>
      <xsl:text> \end{tabular}\par\vfill\flushright</xsl:text>
      <xsl:text>[continued…\par\endgroup\clearpage&#xa;</xsl:text>
      <xsl:for-each select="ancestor::db:tgroup[1]">
        <xsl:call-template name="tabstart"/>
      </xsl:for-each>
      <xsl:for-each select="ancestor::db:tgroup/db:thead[1]">
        <xsl:apply-templates/>
        <xsl:text>[2pt]\hline</xsl:text>
        <xsl:if test="ancestor::db:table/@condition='long'">
          <xsl:text>\endhead</xsl:text>
        </xsl:if>
        <xsl:text>&#xa;</xsl:text>
      </xsl:for-each>
    </xsl:if>
  </xsl:template>
  <xsl:template
    match="db:entry[ancestor::db:thead or
                    ancestor::db:tfoot]">
    <xsl:if test="preceding-sibling::db:entry">
      <xsl:text>&amp;&#xa;</xsl:text>
      <xsl:value-of select="$shield"/>
      <xsl:text> </xsl:text>
    </xsl:if>
    <!-- allow empty headers -->
    <xsl:if test="normalize-space(.)!=''">
      <!-- identify the column number -->
      <xsl:variable name="colpos"
        select="count(preceding-sibling::db:entry) + 1"/>
      <!-- ALWAYS make headers paragraphic,
           which means \multicolumn{1}...
           because we don't know how
           they need to be formatted -->
      <xsl:text>\multicolumn{</xsl:text>
      <xsl:choose>
        <xsl:when test="@spanname">
          <xsl:value-of select="@spanname"/>
        </xsl:when>
        <xsl:otherwise>
          <xsl:text>1</xsl:text>
        </xsl:otherwise>
      </xsl:choose>
      <xsl:text>}{</xsl:text>
      <!-- omit LH shoulder on first column -->
      <xsl:if test="$colpos=1">
        <xsl:text>@{}</xsl:text>
      </xsl:if>
      <xsl:choose>
        <!-- if alignment or width is specified
             in the heading cell itself,
             use local settings,
             honouring local prefix/suffix -->
        <xsl:when test="@align or @colwidth or @wordsize">
          <xsl:call-template name="colprefix">
            <xsl:with-param name="loc" select="'thead'"/>
          </xsl:call-template>
          <xsl:call-template name="colsettings">
            <xsl:with-param name="loc" select="'thead'"/>
          </xsl:call-template>
          <xsl:call-template name="colsuffix">
            <xsl:with-param name="loc" select="'thead'"/>
          </xsl:call-template>
        </xsl:when>
        <!-- otherwise use the column default,
             but use local prefix/suffix by preference -->
        <xsl:otherwise>
          <!-- test for the prefix -->
          <xsl:choose>
            <xsl:when
              test="ancestor::db:tgroup/db:colspec
                    [$colpos]/@condition
                    or
                    ancestor::db:tgroup/db:colspec
                    [$colpos]/@colwidth
                    or
                    ancestor::db:tgroup/db:colspec
                    [$colpos]/@wordsize">
              <xsl:for-each
                select="ancestor::db:tgroup/db:colspec
                        [$colpos]">
                <xsl:call-template name="colprefix">
                  <xsl:with-param name="loc"
                    select="'thead'"/>
                </xsl:call-template>
              </xsl:for-each>
            </xsl:when>
            <xsl:otherwise>
              <xsl:call-template name="colprefix"/>
            </xsl:otherwise>
          </xsl:choose>
          <!-- switch context to the colspec
               to get the settings -->
          <xsl:for-each
            select="ancestor::db:tgroup/db:colspec
                    [$colpos]">
            <xsl:call-template name="colsettings">
              <xsl:with-param name="loc"
                select="'thead'"/>
            </xsl:call-template>
          </xsl:for-each>
          <!-- test for the suffix -->
          <xsl:choose>
            <xsl:when
              test="ancestor::db:tgroup/db:colspec
                    [position()=$colpos]/@condition
                    or
                    ancestor::db:tgroup/db:colspec
                    [position()=$colpos]/@colwidth
                    or
                    ancestor::db:tgroup/db:colspec
                    [position()=$colpos]/@wordsize">
              <xsl:for-each
                select="ancestor::db:tgroup/db:colspec
                        [position()=$colpos]">
                <xsl:call-template name="colsuffix"/>
              </xsl:for-each>
            </xsl:when>
            <xsl:otherwise>
              <xsl:call-template name="colsuffix"/>
            </xsl:otherwise>
          </xsl:choose>
        </xsl:otherwise>
      </xsl:choose>
      <xsl:if
        test="count(following-sibling::db:entry)=0">
        <xsl:text>@{}</xsl:text>
      </xsl:if>
      <xsl:text>}{\sffamily\bfseries </xsl:text>
      <xsl:apply-templates/>
      <xsl:text>}</xsl:text>
    </xsl:if>
  </xsl:template>
  <xsl:template match="db:entry[ancestor::db:tbody]">
    <xsl:variable name="colpos"
      select="count(preceding-sibling::db:entry) + 1"/>
    <xsl:if test="preceding-sibling::db:entry">
      <xsl:text>&amp;</xsl:text>
    </xsl:if>
    <xsl:if test="@spanname">
      <xsl:text>\multicolumn{</xsl:text>
      <xsl:value-of select="@spanname"/>
      <xsl:text>}{</xsl:text>
      <xsl:if
        test="count(preceding-sibling::db:entry)=0">
        <xsl:text>@{}</xsl:text>
      </xsl:if>
      <xsl:choose>
        <!-- if alignment or width is specified,
             use local settings -->
        <xsl:when test="@align or @wordsize">
          <xsl:call-template name="colprefix"/>
          <xsl:call-template name="colsettings"/>
          <xsl:call-template name="colsuffix"/>
        </xsl:when>
        <!-- otherwise use default,
             but check local pre and post -->
        <xsl:otherwise>
          <xsl:call-template name="colprefix"/>
          <xsl:for-each
            select="ancestor::db:tgroup/db:colspec
                    [position()=$colpos]">
            <xsl:call-template name="colsettings"/>
          </xsl:for-each>
          <xsl:call-template name="colsuffix"/>
        </xsl:otherwise>
      </xsl:choose>
      <xsl:if
        test="count(following-sibling::db:entry)=0">
        <xsl:text>@{}</xsl:text>
      </xsl:if>
      <xsl:text>}{</xsl:text>
    </xsl:if>
    <!-- check for hangouts -->
    <xsl:if test="@annotations">
      <xsl:text>\llap{\normalfont </xsl:text>
      <xsl:value-of select="@annotations"/>
      <xsl:text>}</xsl:text>
    </xsl:if>
    <!-- text for headers is in bold -->
    <xsl:if test="../@role='header'">
      <xsl:text>\CPKvstrut\bfseries </xsl:text>
    </xsl:if>
    <!-- check for row-spanned brace-collected -->
    <xsl:if test="@morerows">
      <xsl:if test="@charoff and @char">
        <xsl:text>\llap{</xsl:text>
        <xsl:value-of select="@char"/>
        <xsl:text>{</xsl:text>
        <xsl:value-of select="@morerows"/>
        <xsl:text>}{</xsl:text>
        <xsl:value-of select="@charoff"/>
        <xsl:text>}</xsl:text>
        <xsl:text>}%&#xa;</xsl:text>
        <xsl:value-of select="$shield"/>
        <xsl:text> &#x9;</xsl:text>
      </xsl:if>
      <xsl:text>\multirow{</xsl:text>
      <xsl:value-of select="@morerows"/>
      <xsl:text>}{</xsl:text>
      <xsl:value-of select="@wordsize"/>
      <xsl:text>}{</xsl:text>
    </xsl:if>
    <!-- now we're in the content at last -->
    <xsl:if test="@condition">
      <xsl:value-of select="@condition"/>
      <xsl:text>{}</xsl:text>
    </xsl:if>
    <xsl:choose>
      <!-- mldr &#x2026; on its own (\dotfill)
           needs a \hbox -->
      <xsl:when test=".='\dotfill{}' and @wordsize">
        <xsl:text>\hbox to </xsl:text>
        <xsl:value-of select="@wordsize"/>
        <xsl:text>{</xsl:text>
        <xsl:value-of select="."/>
        <xsl:text>}</xsl:text>
      </xsl:when>
      <!-- hardwired exceptions to special characters -->
      <xsl:when test="@conformance">
        <xsl:value-of select="@conformance"/>
      </xsl:when>
      <xsl:otherwise>
        <xsl:apply-templates/>
      </xsl:otherwise>
    </xsl:choose>
    <!-- additional manual extras before end of cell -->
    <xsl:value-of select="@userlevel"/>
    <!-- end of entry, before any grouping -->
    <xsl:if
      test="ancestor::db:tbody/db:row[1][@rowsep='1']
            and
            ancestor::db:tgroup/db:colspec
            [position()=$colpos][@colwidth]
            and
            not(position()=last())">
      <xsl:text>\vrule depth1em width0pt</xsl:text>
    </xsl:if>
    <xsl:if test="@morerows">
      <xsl:text>}</xsl:text>
    </xsl:if>
    <xsl:if test="@spanname">
      <xsl:text>}</xsl:text>
    </xsl:if>
  </xsl:template>
  <xsl:template match="db:figure">
    <xsl:if
      test="@floatstyle='p'
            and
            descendant::db:imagedata
              [@format='pdf' and @condition]">
      <xsl:value-of select="$shield"/>
      <xsl:text> \clearpage&#xa;</xsl:text>
    </xsl:if>
    <xsl:value-of select="$shield"/>
    <xsl:text> \begin{figure}[</xsl:text>
    <xsl:choose>
      <xsl:when test="@floatstyle">
        <xsl:value-of select="@floatstyle"/>
      </xsl:when>
      <xsl:otherwise>
        <xsl:text>ht</xsl:text>
      </xsl:otherwise>
    </xsl:choose>
    <xsl:text>]</xsl:text>
    <xsl:text>\small\sffamily&#xa;</xsl:text>
    <xsl:apply-templates/>
    <xsl:value-of select="$shield"/>
    <xsl:text> \end{figure}&#xa;</xsl:text>
    <xsl:if test="@floatstyle='p'
                  and
                  descendant::db:imagedata
                    [@format='pdf' and @condition]">
      <xsl:value-of select="$shield"/>
      <xsl:text> \clearpage&#xa;</xsl:text>
    </xsl:if>
  </xsl:template>
  <xsl:template match="db:informalfigure">
    <xsl:value-of select="$shield"/>
    <xsl:text> \begin{center}&#xa;</xsl:text>
    <xsl:apply-templates/>
    <xsl:value-of select="$shield"/>
    <xsl:text> \end{center}&#xa;</xsl:text>
  </xsl:template>
  <xsl:template match="db:mediaobject
                       [not(parent::db:figure)]">
    <xsl:apply-templates/>
  </xsl:template>

  <xsl:template match="db:figure/db:mediaobject |
                       db:informalfigure/db:mediaobject">
    <xsl:if test="@role='framed'">
      <xsl:value-of select="$shield"/>
      <xsl:text> \fbox{\vbox{%</xsl:text>
      <xsl:value-of select="$shield"/>
      <xsl:text>   \advance\hsize by-2\fboxsep</xsl:text>
      <xsl:text>\advance\hsize by-2\fboxrule&#xa;</xsl:text>
    </xsl:if>
    <xsl:apply-templates/>
    <xsl:if test="@role='framed'">
      <xsl:value-of select="$shield"/>
      <xsl:text> }}&#xa;</xsl:text>
    </xsl:if>
  </xsl:template>
  <xsl:template match="db:imageobject">
    <xsl:choose>
      <!-- detect a previous image -->
      <xsl:when test="preceding-sibling::*[1]
                      [local-name()='imageobject']">
        <xsl:choose>
          <xsl:when test="@dir='ltr'">
            <xsl:value-of select="$shield"/>
            <xsl:text> \quad\vrule\quad&#xa;</xsl:text>
          </xsl:when>
          <xsl:when test="ancestor::db:figure">
            <xsl:value-of select="$shield"/>
            <xsl:text> \par&#xa;</xsl:text>
          </xsl:when>
          <xsl:otherwise>
            <xsl:value-of select="$shield"/>
            <xsl:text> \\&#xa;</xsl:text>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:when>
      <xsl:otherwise>
        <xsl:text></xsl:text>
      </xsl:otherwise>
    </xsl:choose>
    <xsl:apply-templates/>
  </xsl:template>
  <xsl:template match="db:imagedata">
    <!-- alignment -->
    <xsl:choose>
      <xsl:when test="@align='center' or not(@align)">
        <xsl:value-of select="$shield"/>
        <xsl:text> \centering&#xa;</xsl:text>
      </xsl:when>
      <xsl:when test="@align='right'">
        <xsl:value-of select="$shield"/>
        <xsl:text> \flushright&#xa;</xsl:text>
      </xsl:when>
    </xsl:choose>
    <!-- reframe non-PDFs ??? -->
    <xsl:if test="@arch='framed' and not(@format='pdf')">
      <xsl:value-of select="$shield"/>
      <xsl:text> </xsl:text>
      <xsl:if test="@contentdepth">
        <xsl:text>\fboxsep</xsl:text>
        <xsl:value-of select="@contentdepth"/>
      </xsl:if>
      <xsl:text>\fbox{%&#xa;</xsl:text>
    </xsl:if>
    <xsl:choose>
      <xsl:when test="@fileref">
        <xsl:choose>
          <xsl:when test="@format='pdf' and @condition">
            <xsl:value-of select="$shield"/>
            <xsl:text> \includepdf</xsl:text>
          </xsl:when>
          <xsl:otherwise>
            <xsl:value-of select="$shield"/>
            <xsl:text> \includegraphics</xsl:text>
          </xsl:otherwise>
        </xsl:choose>
        <xsl:text>[</xsl:text>
        <xsl:choose>
          <xsl:when test="@condition">
            <xsl:value-of
              select="normalize-space(@condition)"/>
            <xsl:if
              test="@arch='framed' and @format='pdf'">
              <xsl:text>,frame</xsl:text>
            </xsl:if>
          </xsl:when>
          <xsl:when test="@width">
            <xsl:text>width=</xsl:text>
            <xsl:choose>
              <xsl:when test="contains(@width,'%')">
                <xsl:value-of
                  select="number(substring-before
                          (@width,'%'))
                          div 100"/>
                <xsl:text>\columnwidth</xsl:text>
              </xsl:when>
              <xsl:otherwise>
                <xsl:value-of select="@width"/>
              </xsl:otherwise>
            </xsl:choose>
          </xsl:when>
          <xsl:when test="@depth">
            <xsl:text>height=</xsl:text>
            <xsl:choose>
              <xsl:when test="contains(@depth,'%')">
                <xsl:value-of
                  select="number(substring-before
                          (@depth,'%'))
                          div 100"/>
                <xsl:text>\textheight</xsl:text>
              </xsl:when>
              <xsl:otherwise>
                <xsl:value-of select="@depth"/>
              </xsl:otherwise>
            </xsl:choose>
          </xsl:when>
          <xsl:when test="@scalefit='1'">
            <xsl:text>width=.5\columnwidth</xsl:text>
          </xsl:when>
          <xsl:otherwise>
            <xsl:variable name="numpix"
              select="count(ancestor::db:mediaobject
                            /db:imageobject)"/>
            <xsl:variable name="numpixfrac"
              select="1 div $numpix"/>
            <xsl:text>width=</xsl:text>
            <xsl:value-of select="$numpixfrac"/>
            <xsl:text>\columnwidth</xsl:text>
            <!-- allow for the \quad\vrule\quad
                 between multiple images
                 for which we use the
                 notional value 2.2em -->
            <xsl:if test="$numpix>1">
              <xsl:text> - </xsl:text>
              <xsl:value-of select="($numpix - 1)*2.2"/>
              <xsl:text>em</xsl:text>
            </xsl:if>
            <xsl:if test="@arch='framed'">
              <xsl:text> - 2\fboxsep - 1\fboxrule</xsl:text>
            </xsl:if>
          </xsl:otherwise>
        </xsl:choose>
        <xsl:text>]</xsl:text>
        <xsl:text>{</xsl:text>
        <xsl:value-of select="@fileref"/>
        <xsl:text>}</xsl:text>
      </xsl:when>
      <xsl:when test="@remap">
        <xsl:value-of select="$shield"/>
        <xsl:text> </xsl:text>
        <xsl:if test="@condition">
          <xsl:text>{</xsl:text>
          <xsl:value-of
            select="normalize-space(@condition)"/>
        </xsl:if>
        <xsl:value-of select="@remap"/>
        <xsl:if test="@condition">
          <xsl:text>}</xsl:text>
        </xsl:if>
      </xsl:when>
      <xsl:otherwise>
        <xsl:text>IMAGE</xsl:text>
      </xsl:otherwise>
    </xsl:choose>
    <xsl:if test="@arch='framed'
                  and
                  not(@format='pdf')">
      <xsl:text>}</xsl:text>
    </xsl:if>
    <xsl:text>&#xa;</xsl:text>
  </xsl:template>
  <xsl:template match="db:textobject">
    <xsl:text>\\[3pt]\raggedright&#xa;</xsl:text>
    <xsl:apply-templates/>
  </xsl:template>

</xsl:stylesheet>

